unit GrAlap;  {grafikus alapelemek}
interface
 uses Crt,Graph;

 {*** GRAFIKUS INIT, GrUt: BGI s CHR fjlok helye,
                     eredmny : sikeres init -e}
 function GrInit(GrUt:string;var GrHiba:Integer): Boolean;

 type
  Szin  =Word;
  Koord =Integer;
  TLap  =record
          O1,S1: Koord; {bal fels}
          O2,S2: Koord; {jobb als}
         end;
  Kor   =record
          X,Y: Koord; {centrum}
          R:   Word;  {sugr}
         end;

  BetuTipus =Word;
  Iranyitas =HorizDir..VertDir;
  IgazitasV =LeftText..RightText;   {CenterText}
  IgazitasF =BottomText..TopText;
  ToltoMinta=EmptyFill..UserFill;

 { betmagassg adott bettipus s mret esetn }
 function BetuMag(Betu:BetuTipus; Meret: Word): Word;

 { szvegszlessg adott bettipus s mret esetn }
 function SzovegSzel(s:string;Betu:BetuTipus; Meret: Word): Word;

 {*** MENTS, VISSZALLITS a grafikus jellemzkre }
 type
  SzinToltJellemzok= record
   RSzin: Szin;                {rajzszin}
   ToltJell:FillSettingsType;
  end;
  SzinVonalJellemzok= record
   RSzin: Szin;                {rajzszin}
   VonalJell:LineSettingsType;
   IrasMod  :Integer;          {ld. SetWriteMod}
  end;

 {szvegjellemzk}
 procedure SzovJellMent(var SzovJell: TextSettingsType);
 procedure SzovJellVissza(SzovJell: TextSettingsType);
 {rajzszin s tltsi jellemzk}
 procedure RSzinToltMent(var SzinToltJell:SzinToltJellemzok);
 procedure RSzinToltVissza( SzinToltJell:SzinToltJellemzok);
 {rajzszin s vonal jellemzk}
 procedure RSzinVonalMent(var SzinVonalJell:SzinVonalJellemzok);
 procedure RSzinVonalVissza(SzinVonalJell:SzinVonalJellemzok);

 { az a s b minimuma}
 function MiniMal(a,b:Word):Word;
 {az [a,b] intervallum egy vletlen rtke}
 function RandAB(a,b:Word):Word;
 {a pont a tglalap belsejbe esik-e}
 function TLapba(T:TLap; X,Y: Koord): Boolean;
 {a pont a kr belsejbe esik-e}
 function Korbe(K:Kor; X,Y: Koord): Boolean;

implementation

 function GrInit;
 var
  GrMeghajto: Integer; GrMod: Integer;
 begin
  GrMeghajto := Detect; InitGraph(GrMeghajto, GrMod, GrUt);
  GrHiba := GraphResult;  GrInit:= GrHiba=grOk;
 end;

 procedure SzovJellMent;
 begin
  GetTextSettings(SzovJell);
 end;

 procedure SzovJellVissza;
 begin
  with SzovJell do begin
   SetTextStyle(Font,Direction,CharSize); SetTextJustify(Horiz,Vert);
  end;
 end;

 procedure RSzinToltMent;
 begin
  with SzinToltJell do begin
   RSzin:=GetColor; GetFillSettings(ToltJell);
  end;
 end;

 procedure RSzinToltVissza;
 begin
  with SzinToltJell do begin
   SetColor(RSzin); with ToltJell do SetFillStyle(Pattern,Color);
  end;
 end;

 procedure RSzinVonalMent;
 begin
  with SzinVonalJell do begin
   RSzin:=GetColor; GetLineSettings(VonalJell);
  end;
 end;

 procedure RSzinVonalVissza;
 begin
  with SzinVonalJell do begin
   SetColor(RSzin);
   with VonalJell do SetLineStyle(LineStyle,Pattern,Thickness);
   SetWriteMode(NormalPut);
  end;
 end;

 function BetuMag;
 var SzovJell: TextSettingsType;
 begin
  SzovJellMent(SzovJell);
  SetTextStyle(Betu, HorizDir,Meret); BetuMag:=TextHeight('H');
  SzovJellVissza(SzovJell);
 end;

 function SzovegSzel;
 var SzovJell: TextSettingsType;
 begin
  SzovJellMent(SzovJell);
  SetTextStyle(Betu,HorizDir,Meret); SzovegSzel:=TextWidth(s);
  SzovJellVissza(SzovJell);
 end;

 function MiniMal;
 var c:Longint;
 begin
  c:=a; if b<a then c:=b; MiniMal:=c;
 end;

 function RandAB;
 begin
  RandAB:= Random(b-a+1)+a;
 end;

 function TLapba;
 begin
  with T do TLapba:=(X>O1) and (X<O2) and (Y>S1) and (Y<S2);
 end;

 function Korbe;
 begin
  Korbe:=(Longint(K.X-X)*(K.X-X)+Longint(K.Y-Y)*(K.Y-Y))<Longint(K.R)*K.R
 end;
end.
