unit GrSzKom;  {grafikus szvegkommunikci}
interface
 uses Crt,Graph,StandDef,StandKom,GrAlap,GrKepKom;
 {*** KPERNYRE IRS}
 {ltalnos megjegyzsek: - ha a sor s/vagy az oszlop paramter <=0, akkor a
                            pozici az aktulis sor s/vagy oszlop lesz
                          - rs utn visszalltjuk az eredeti jellemzket
                            (szin, minta, betforma, mret stb.)
                          - tglalapot mindig
                              bal fels (O1,S1) - jobb als (O2,S2)
                            sorrendben adunk meg }

 {ltalnos r eljrs}
 procedure GrAltIr(Mit:string;           { kiirand }
                   Oszl,Sor: Koord;      { hely     }
                   Margo   : Byte;       { marg szlessge}
                   Betu    : BetuTipus;  { bettpus}
                   Irany   : Iranyitas;  { irsirny}
                   Meret   : Word;       { betmret}
                   IgazitV : IgazitasV;  { vizszintes igazits}
                   IgazitF : IgazitasF;  { fggleges igazits}
                   BetuSzin: Szin;       { betszin }
                   HatSzin : Szin;       { httrszin}
                   HatMinta: ToltoMinta);{ httrminta}

 { rs az aktulis szvegjellemzkkel}
 procedure GrAktIr(Mit:string;           { kiirand }
                   Oszl,Sor: Koord;      { hely     }
                   Margo   : Byte;       { marg szlessge}
                   BetuSzin: Szin;       { betszin }
                   HatSzin : Szin;       { httrszin}
                   HatMinta: ToltoMinta);{ httrminta}

 { rs az alap (default) szvegjellemzkkel:
   bettpus=DefaultFont, irnyits = HorizDir, mret = 1, marg =1
   igazits  = LeftText - CenterText }
 procedure GrAlapIr(Mit:string;           { kiirand }
                    Oszl,Sor: Koord;      { hely     }
                    BetuSzin: Szin;       { betszin }
                    HatSzin : Szin;       { httrszin}
                    HatMinta: ToltoMinta);{ httrminta}

 {a szveget (jobbrl) vgja, hogy belefrjen az adott hosszba}
 procedure GrSzovVag(var Mit:string; Betu: BetuTipus; Meret: Word;
                     Hossz:Word);

 {a tglalapot tlti a megadott httrszin s minta szerint, majd a
  kzepre irja a szveget (esetleges vgssal)}
 procedure GrKozepIr(Mit:string;              { kiirand }
                     O1,S1,O2,S2: Koord;      { tglalap }
                     Betu       : BetuTipus;  { bettpus}
                     Irany      : Iranyitas;  { irsirny}
                     Meret      : Word;       { betmret}
                     BetuSzin   : Szin ;      { betszin }
                     HatSzin    : Szin;       { httrszin}
                     HatMinta   : ToltoMinta);{ httrminta}

 {a keret fejlcrszt ujrairja, 1-es mrettel s default bettipussal}
 procedure GrFejlec(Cim:string);

 {*** ZENET s vlaszkezels}
 { zenetet ir, balra igazitva  }
 procedure GrUzen(Mit:string);
 {az zenetre a ValJel valamely jelt vrja vlaszknt, ha az nem res,
  ha res, akkor brmely jelet elfogad}
 function GrJelVal(MitUzen:string;ValJel:Jelek):Char;
 {zenetet r s Enter utn tovbblp}
 procedure GrTovabb(Uzenet:string);

 {az zenet eldntend krds, 'i' vagy  'i ' (=igen) vagy
                               'n' vagy  'n'  (=nem)  a vlasz}
 function GrIgenVal(MitUzen:string):Boolean;


 implementation

 procedure GrAltIr;
 var
  SzovJell: TextSettingsType;
 begin
  SzovJellMent(SzovJell);
  {belltsok}
  SetTextStyle(Betu,Irany,Meret); SetTextJustify(IgazitV,IgazitF);
  {rs}
  GrAktIr(Mit,Oszl,Sor,Margo,BetuSzin,HatSzin,HatMinta);
  SzovJellVissza(SzovJell);
 end;

 procedure GrAktIr;
 var
  SzinToltJell: SzinToltJellemzok; O1,S1,O2,S2: Koord;
  SzovJell: TextSettingsType;  SzMag,SzSzel: Word;
  SEltol, OEltol: Integer;
 begin
  if Oszl<=0 then Oszl:=GetX; if Sor<=0 then Sor:=GetY; {hely bellts}
  RSzinToltMent(SzinToltJell);
  {az irsblokk (tglalap) meghatrozsa}
  GetTextSettings(SzovJell);
  with SzovJell do begin
   case Direction of
    HorizDir: begin SzMag:=TextHeight(Mit); SzSzel:=TextWidth(Mit) end;
    VertDir : begin SzSzel:=TextHeight(Mit);SzMag :=TextWidth(Mit) end;
   end;
   {alap: left - top}
   O1:=Oszl-Margo; O2:=Oszl+SzSzel+Margo;
   S1:=Sor-Margo;  S2:=Sor+SzMag+Margo;
   case Horiz of
    LeftText:   OEltol:=0;
    CenterText: OEltol:=-(SzSzel div 2);
    RightText : OEltol:=-SzSzel;
   end;
   case Vert of
    BottomText: SEltol:=-SzMag;
    CenterText: SEltol:=-(SzMag div 2);
    TopText   : SEltol:=0;
   end;
   {korrekci}
   if (Font=DefaultFont) and (Direction=VertDir) and (Horiz=LeftText)
      then OEltol:=-SzSzel;
  end;
  S1:=S1+SEltol; S2:=S2+SEltol; O1:=O1+OEltol; O2:=O2+OELtol;
  {belltsok, rajzols, rs}
  SetColor(BetuSzin); SetFillStyle(HatMinta,HatSzin);
  Bar(O1,S1,O2,S2); OutTextXY(Oszl,Sor,Mit);
  RSzinToltVissza(SzinToltJell);
 end;

 procedure GrAlapIr;
 begin
  GrAltIr(Mit,Oszl,Sor,1,DefaultFont,HorizDir,1,LeftText,CenterText,
          BetuSzin,HatSzin,HatMinta);
 end;

 {a szveget (jobbrl) vgja, hogy belefrjen az adott hosszba}
 procedure GrSzovVag(var Mit:string; Betu: BetuTipus; Meret: Word;
                     Hossz:Word);
 var
  SzovJell: TextSettingsType;
 begin
  SzovJellMent(SzovJell); SetTextStyle(Betu,HorizDir,Meret);
  while TextWidth(Mit)>Hossz do Delete(Mit,Length(Mit),1);
  SzovJellVissza(SzovJell);
 end;

 procedure GrKozepIr;
 begin
  {tglalap }
  GrAblTorl(O1,S1,O2,S2,HatSzin,HatMinta);
  {vgs}
  case Irany of
   HorizDir: GrSzovVag(Mit,Betu,Meret,O2-O1);
   VertDir : GrSzovVag(Mit,Betu,Meret,S2-S1);
  end;
  {szveg}
  GrAltIr(Mit,(O2+O1) div 2,(S2+S1) div 2,0,Betu,Irany,Meret,
          CenterText,CenterText, BetuSzin,HatSzin,HatMinta);
 end;

 procedure GrFejlec;
 begin
  with KeretAdat.Osztas.FejT do
  GrKozepIr(Cim,O1,S1,O2,S2,DefaultFont,HorizDir,1,
            KeretAdat.Szinek.FejLecSzin,GetBkColor, SolidFill);
 end;

 procedure GrUzen;
 begin
  with KeretAdat.Osztas.UzenT do begin
   GrAblTorl(O1,S1,O2,S2,GetBkColor,SolidFill);
   GrAlapIr(Mit,O1+3,(S1+S2) div 2,KeretAdat.Szinek.UzenSzin,GetBkColor,
            SolidFill);
  end;
 end;

 function GrJelVal;
 begin
  GrUzen(MitUzen);
  if ValJel=[] then GrJelVal:=ReadKey else GrJelVal:=JelBeUp(ValJel);
 end;

 procedure GrTovabb;
 begin
  GrJelVal(Uzenet+' (Tovbb:Enter)',[Valaszt]);
 end;

 function GrIgenVal;
 begin
  GrIgenVal:=GrJelVal(MitUzen,['I','N']) ='I';
 end;
end.


