unit GrVlKomE;  {grafikus billentys/egeres men - kurzor kommunikci}
interface
 uses
  Crt,StandDef,Graph,GrAlap,GrSzKom,GrKepKom,EgerKez;

 {*** MENKEZELS}
 {a vlaszts mind billentyvel, mind egrrel mkdik
  az els MenuDb mensor kerl kiajnlsra
  indulskor a Kezd  sorra ll, a Menu[0] a cimbe   kerl
  a visszaadott rtk
    - 0, ha nem volt vlaszts
    - a vlasztott sor szma, ha volt vlaszts
  ha az Uj=True, akkor a szubrutin a menterlet trlsvel indul}

 function GrMenu(Menu:MenuSorok;MenuDb,Kezd:MenuInd;Uj:Boolean):MenuInd;

 {*** KURZOR s MARKER KEZELS }
 { A Kurzor fggvny az egr llapottl fggen az ugyanugy
   paramterezett billentys BKurzor, vagy az egeres
   EKurzor - t hvja meg}

 function Kurzor(CML      : TLap;  { i a vlasztsi terlet}
                 Info     : string;{ i kisr zenet}
                 var CX,CY: Koord; { i/o a pont }
                 var CC   : Szin)  { o   a pont szine}
                 : Boolean;        { o   volt-e vlaszts}

 { a marker (jell) eljrs egy pontot jell meg (CX,CY) a
   munkaterleten egy kereszttel, szine a kurzor szine, ismtelt
   hivs a jellst trli}

 procedure Marker(CX,CY: Koord);

 {a munkaterlet als rszn grafikus szinvlaszts, a fellirt
  terlet visszallitsval (a httrszin nem vlaszthat) }

 function SzintValaszt(Mag: Byte; { i a szinlap magassga}
                       var V:Szin { o vlasztott szin}
                       ):Boolean; {volt vlaszts}

 procedure CRajz(X,Y:Integer; Mit: Boolean);


 implementation

  function EBillBe(Normal:Jelek; Dupla:Jelek; var Duplae:Boolean):Char;
   {eredmny a jel (ha funkcibillenty, akkor enne msodik jele),
   ha volt rvnyes billenty, egybknt #0 }
  var
   Jel :Char; Voltjel :Boolean;
  begin
   if KeyPressed then begin
    Jel:=ReadKey; Duplae:=Jel=#0; if Duplae then Jel:=ReadKey;
    Voltjel:=(not Duplae and (Jel in Normal)) or (duplae and (jel in dupla));
    if not voltjel then jel:=#0;
   end else jel:=#0;
   EBillBe:=Jel;
  end;

  { Norml billenty jelnek bekrse visszars nlkl egrkezels mellett }
  function EJelBe(Jojelek:Jelek):Char;
  var
   duplae:boolean;
  begin
   EJelBe:=EBillBe(JoJelek,[],duplae);
  end;

  {Irny, vagy kilps ill. vlaszts bekrse egrkezels mellett }
   function ELepesBe:Lepes;
  var
   duplae:Boolean;
  begin
   ELepesBe:=EBillBe([Valaszt,KiLep],Iranyok,duplae);
  end;

 function GrMenu;
  const
   MTLap:array[MenuInd] of Tlap= {a mensorok elhelyezse}
         ((O1:0;S1:0;O2:0;S2:0),(O1:0;S1:0;O2:0;S2:0),(O1:0;S1:0;O2:0;S2:0),
          (O1:0;S1:0;O2:0;S2:0),(O1:0;S1:0;O2:0;S2:0),(O1:0;S1:0;O2:0;S2:0),
          (O1:0;S1:0;O2:0;S2:0),(O1:0;S1:0;O2:0;S2:0),(O1:0;S1:0;O2:0;S2:0),
          (O1:0;S1:0;O2:0;S2:0));
   HatMinta: array[Boolean] of ToltoMinta=(SolidFill,SolidFill);
  var
   i:MenuInd; Valasz:Lepes;
  procedure MenuSorIr(i:MenuInd; Kiemelt:Boolean);
  begin
   EgerKi;
   with MTLap[i],KeretAdat.Szinek do
   if i=0 then GrKozepIr(Menu[i],O1,S1,O2,S2,DefaultFont,HorizDir,
                         1,MenuBetuSzin,GetBkColor,SolidFill)
   else GrKozepIr(Menu[i],O1,S1,O2,S2,DefaultFont,HorizDir,
                  1,MenuBetuSzin,MenuHatSzin,HatMinta[Kiemelt]);
   EgerBe;
  end;

  procedure MenuLep(var i:MenuInd; hova:MenuInd);
  begin
   if hova<>i then begin
    MenuSorIr(i,False); MenuSorIr(hova,True); i:=hova;
   end;
  end;

  function EMenuLap:Menuind;
  var lap,j:MenuInd; x,y:Word;
  begin
    EgerPozicio(x,y);
    lap:=0; j:=0;
    repeat
      Inc(j);
      if TLapba(MTLap[j],x,y) then lap:=j;
    until (lap<>0) or (j=MenuDb);
    EMenuLap:=lap;
  end;

 const
  MagA =0.75; {kt tglalap kzti 'hzag' arnya a tglalap magassghoz}
  SzelA=0.8; {a tglalap szlessg arnya a menterlet szlessghez}
 var
  e,co1,co2,s:Word; c:Real; ujlap:MenuInd;
 begin
  with KeretAdat.Osztas.MenuT, KeretAdat.Szinek do begin
   if Uj then begin
    EgerKi;
    GrAblTorl(O1,S1,O2,S2,GetBkColor,SolidFill); {trls}
    EgerBe;
    HatMinta[True]:=SolidFill; HatMinta[False]:=MenuMinta;
    {elhelyezs}
    c:=(1-SzelA)*(O2-O1)/2;co1:=Round(O1+c); co2:=Round(O2-c);
    e:=Trunc((S2-S1)/(MenuDb+(MenuDb+4)*MagA)); s:=S1+Round(MagA*e);
    for i:=0 to MenuDb do begin
     MTLap[i].O1:=co1;  MTLap[i].O2:=co2;
     MTLap[i].S1:=s;    MTLap[i].S2:=s+e-1;
     s:=Round(s+(1+MagA)*e);
    end;
    for i:=0 to MenuDb do MenuSorIr(i,False);
   end;
  end;
  i:=Kezd; MenuSorIr(i,True);
  EgerKi; GrUzen(MenuInfo); EgerBe;
  repeat
   if EgerMukodik and EgerBalGomb then begin
     ujlap:=EMenuLap;
     if ujlap<>0 then begin
       MenuLep(i,ujlap); Valasz:=Valaszt;
     end;
     while EgerBalGomb do;
   end else begin
    Valasz:=ELepesBe;
    case Valasz of
     Eleje:MenuLep(i,1);
     Vege :MenuLep(i,MenuDb);
     Fel  :if i>1 then Menulep(i,i-1);
     Le   :if i<MenuDb then Menulep(i,i+1);
    end;
   end;
  until Valasz in [Valaszt,KiLep];
  MenuSorIr(i,False);
  EgerKi; GrUzen(' '); EgerBe;
  if Valasz=Valaszt then GrMenu:=i else GrMenu:=0;
 end;

 {kurzorleir adatok}
 const
  CLepMax =10; CMeret = 11; CSzel=(CMeret-1) div 2; CKozp=CSzel div 2;
  CInfo=#24#25#26#27' Home Enter Esc + -';
 {a kurzor s marker kzs rajzol eljrsa,
  kurzor: Mit=True, marker: Mit=False}
 procedure CRajz(X,Y:Integer; Mit: Boolean);
 var
  SzinVonalJell: SzinVonalJellemzok;
 begin
  RSzinVonalMent(SzinVonalJell);
  SetColor(KeretAdat.Szinek.KurzorSzin); SetLineStyle(SolidLn,0,NormWidth);
  SetWriteMode(XORPut);
  EgerKi;
  if Mit then Rectangle(X-CSzel,Y-CSzel,X+CSzel,Y+CSzel);
  Line(X-CKozp,Y,X+CKozp,Y); Line(X,Y-CKozp,X,Y+CKozp);
  EgerBe;
  RSzinVonalVissza(SzinVonalJell);
 end;

 function BKurzor(CML      : TLap; { i a kurzormozgsi terlet}
                 Info     : string;{ i kisr zenet}
                 var CX,CY: Koord; { i/o a pont }
                 var CC   : Szin)  { o   a pont szine}
                 : Boolean;        { o   volt-e vlaszts}
 var
  Leptek:1..CLepMax;  J1,J2: Char;
 begin
  with KeretAdat.Osztas.MunkaT do begin
   if CML.O1<O1 then CML.O1:=O1; if CML.O2>O2 then CML.O2:=O2;
   if CML.S1<S1 then CML.S1:=S1; if CML.S2>S2 then CML.S2:=S2;
  end;
  if not TLapba(CML,CX,CY) then with CML do begin
   CX:=(O1+O2) div 2; CY:=(S1+S2) div 2;
  end;
  CRajz(CX,CY,True); GrUzen(Info+CInfo); Leptek:=CLepMax div 2;
  with CML do
  repeat
   J2:=#0; J1:=ReadKey; if J1=#0 then J2:=ReadKey;
   CRajz(CX,CY,True);
   case J1 of
    '+': if Leptek<CLepMax then Inc(Leptek);
    '-': if Leptek>1 then Dec(Leptek);
   end;
   case J2 of
    Eleje:begin CX:=(O1+O2) div 2; CY:=(S1+S2) div 2 end;
    Fel  :if CY-Leptek>S1 then Dec(CY,Leptek);
    Le   :if CY+Leptek<S2 then Inc(CY,Leptek);
    Jobb :if CX+Leptek<O2 then Inc(CX,Leptek);
    Bal  :if CX-Leptek>O1 then Dec(CX,Leptek);
   end;
   CRajz(CX,CY,True);
  until J1 in [Valaszt,KiLep];
  CRajz(CX,CY,True);  GrUzen(' '); BKurzor:=J1=Valaszt;
  CC:=GetPixel(CX,CY);
 end;

 function EKurzor(cml      :TLap;  { i ahol elfogadjuk a kattintst}
                 info      :String;{ i kisr zenet}
                 var cx,cy :Koord; { i/o a pont }
                 var cc    :Szin)  { o   a pont szine}
                 : Boolean;        { o   volt-e vlaszts}
 var
  jel:Char; x,y:Word;
 begin
  EgerKi; GrUzen(Info+'Bal egrgomb  Esc'); EgerBe;
  repeat
   if EgerKattintas=egBalGomb then begin
    EgerPozicio(x,y);
    if TLapba(CML,x,y) then begin jel:=Valaszt; cx:=x; cy:=y end;
   end else
    jel:=EJelBe([KiLep]);
  until Jel in [Valaszt,KiLep];
  EgerKi; GrUzen(' '); CC:=GetPixel(cx,cy); EgerBe;
  EKurzor:=Jel=Valaszt;
 end;

 function Kurzor (cml      :TLap;  { i ahol elfogadjuk a kattintst}
                 info      :String;{ i kisr zenet}
                 var cx,cy :Koord; { i/o a pont }
                 var cc    :Szin)  { o   a pont szine}
                 : Boolean;        { o   volt-e vlaszts}
 begin
  if EgerMukodik then Kurzor:=EKurzor(cml,info,cx,cy,cc)
                 else Kurzor:=BKurzor(cml,info,cx,cy,cc);
 end;

 procedure Marker;
 begin
  if TLapba(KeretAdat.Osztas.MunkaT,CX,CY) then CRajz(CX,CY,False);
 end;

 function SzintValaszt;
 var
  Vter:TLap; {vlasztsi terlet} i,j,m,sz: Word; P:Pointer;
  SzinToltJell:SzinToltJellemzok; x,y: Koord;

 begin
  with VTer,KeretAdat.Osztas do begin
   O1:=MunkaT.O1; O2:=MunkaT.O2; S1:=MunkaT.S2-Mag+11; S2:=MunkaT.S2;
   m:=ImageSize(O1,S1,O2,S2);
   if m>MaxAvail then begin
    GrTovabb(' Memria kevs, szin nem vlaszthat !');
    SzintValaszt:=False;
   end
   else begin
    EgerKi;
    GetMem(P,m); GetImage(O1,S1,O2,S2,P^);  {ments}
    RSzinToltMent(SzinToltJell);
    j:=0; sz:=Trunc((MunkaT.O2-MunkaT.O1+1)/(GetMaxColor-1));
    for i:=1 to GetMaxColor do if i<>GetBkColor then begin
     SetFillStyle(SolidFill,i);
     Bar(O1+j*sz,S1,O1+(j+1)*sz,S2); Inc(j);
    end;
    EgerBe;
    Dec(j); Bar(O1+j*sz,S1,MunkaT.O2,S2);
    SzintValaszt:=Kurzor(VTer,'Szinvlaszts: ',x,y,V);
    RSzinToltVissza(SzinToltJell);
    EgerKi; PutImage(O1,S1,P^,NormalPut); EgerBe; Freemem(P,m);
   end;
  end;
 end;
end.


