unit SzovKez; {szvegkezels}
interface
 function JelSor(C:char;H:Byte):string;
  {az eredmny egy H hossz, csupa C jelbl ll string}
 function Szokoz(H:Byte):string;
  {az eredmny egy H db. szkzbl ll string}
 function BalVag(S:string):string;
  {az eredmny az S rtkbl a kezd szkzk trlsvel keletkezik}
 function JobbTolt(S:string;H:Byte):string;
  {az eredmny az S rtknek H hosszban balra igazitsval s
  jobbrl szkzkkel val feltltsvel keletkezik }
 function JobbVag(S:string):string;
  {az eredmny az S rtkbl a befejez szkzk trlsvel keletkezik}
 function BalTolt(S:string;H:Byte;Tolto:Char):string;
  {az eredmny az S rtknek H hosszban jobbra igazitsval s
  balrl a Tolto karakterrel val feltltsvel keletkezik }
 function ElolNull(S:string;H:Byte):string;
  {az eredmny az S rtknek egy H hossz, az els nem szkz jelig
  balrl nullkkal feltlttt stringg alakitsval keletkezik }

  {ltalnos megjegyzs: a JobbTolt s BalTolt fggvnyek
   rtkes(nemszkz) jelet nem vgnak le}

 procedure KiVag(var Mibol:string; Mit:string);
 {a Mibol rtkbl a Mit rtke els elfordulst eltvoltja}
 procedure UpSzov(var S:string);
  {az S minden jelre vgrehajtjuk a nagybetv alaktst (UpCase)}
 function LowJel(C:Char):Char;
 {a C kisbets alakja}
 procedure LowSzov(var S:string);
  {az S minden jelre vgrehajtjuk a kisbetv alaktst }

implementation
 function JelSor;
  var i:Byte; s:string;
 begin
  FillChar(s,H+1,C); s[0]:=Chr(H); JelSor:=s;
 end;

 function Szokoz;
 begin
  Szokoz:=JelSor(' ',H);
 end;

 function BalVag;
  var i:Byte;
 begin
  i:=1;
  while (i<=Length(S)) and  (S[i]=' ') do i:=i+1;
  BalVag:=Copy(s,i,Length(S)-(i-1));
 end;

 function JobbTolt;
  var i:Byte;
 begin
  S:=BalVag(S);
  if H>Length(S) then for i:=Length(S)+1 to H do S:=S+' ';
  JobbTolt:=S;
 end;

 function JobbVag;
  var i:Byte;
 begin
  i:=Length(S);
  while (S[i]=' ') and (i>0) do i:=i-1;
  S[0]:=Chr(i); JobbVag:=S
 end;

 function BalTolt;
  var i:Byte;
 begin
  S:=JobbVag(BalVag(S));
  for i:=Length(S)+1 to H do S:=Tolto+S;
  BalTolt:=S;
 end;

 function ElolNull;
  var i:Byte;
 begin
  ElolNull:=BalTolt(S,H,'0');
 end;

 procedure KiVag;
  var i:Byte;
 begin
  i:=Pos(Mit,Mibol); if i>0 then Delete(Mibol,i,Length(Mit));
 end;

 procedure UpSzov;
  var i:Byte;
 begin
  for i:=1 to Length(S) do S[i]:=UpCase(S[i]);
 end;

 function LowJel;
 begin
  if C in ['A'..'Z'] then Inc(C,Ord('a')-Ord('A'));
  LowJel:=C;
 end;

 procedure LowSzov;
  var i:Byte;
 begin
  for i:=1 to Length(S) do S[i]:=LowJel(S[i]);
 end;
end.
