unit GrafDekl;      { Grf deklarcik }

interface

const
  Fejlec = 'Grf demonstrcis program';

const
  MinPont = 'a';
  MaxPont = 'z';

  MaxPontDb = Ord(MaxPont) - Ord(MinPont) + 1;
  MaxElDb = MaxPontDb * (MaxPontDb-1);

  MaxPontTip = 6;
  MaxUtKat = 9;

  MinKoord = -999999;
  MaxKoord =  999999;

type
  Koord = MinKoord..MaxKoord;       { 'nagy' koordinta }
  KoordInt = Integer;               { grafikus koordinta }

  PontTip = 1..MaxPontTip;          { csak a sznezs vgett ekkork }
  UtKatTip = 1..MaxUtKat;           { sznek a GrafGraf unitban }

  { pontok }
  PontAzonTip = MinPont..MaxPont;  { pontazonost }
  PontRekTip = record              { pontadat: azonost, tpus, koordinta }
    Azon :PontAzonTip;
    Tip  :PontTip;
    x, y :Koord;
  end;
  PontDbTip = 0..MaxPontDb;                      { pontok szma }
  PontIndTip = 1..MaxPontDb;                     { pontindex }
  PontokTip = array[PontIndTip] of PontRekTip;   { pontok adatai }

  GrafPontokTip = record
    PontDb :PontDbTip;  { pontok szma }
    Pontok :PontokTip;  { azonost szerint rendezettek }
  end;

  { lek }
  ElHossz = Word;           { lhossz }

  { ltrols esetn }
  ElRekTip = record         { ladat: vgpontindex, hossz, kategria }
    VpInd :PontIndTip;
    Hossz :ElHossz;
    UtKat :UtKatTip;
  end;
  ElDbTip = 0..MaxElDb;                           { lek szma }
  ElIndTip = 1..MaxElDb;                          { lindex }
  ElekTip = array[ElIndTip] of ElRekTip;          { lek adatai }

  { lmutatk }
  PontIndTip1 = 1..MaxPontDb+1;                   { a tmb indexe }
  ElIndTip1 = 1..MaxElDb+1;                       { a tmb elemei }
  ElMutTip = array[PontIndTip1] of ElIndTip1;     { az lmutat tmb }

  GrafElekTip1 = record
    ElMut :ElMutTip;  { az lmutatk }
    Eldb  :ElDbTip;   { lek szma }
    Elek  :ElekTip;   { egy pont lei vgpont szerint rendezettek }
  end;

  { mtrixtrols esetn }
  HosszMtxTip = array[PontIndTip,PontIndTip] of ElHossz;     { hossz-mtrix }
  UtKatMtx = array[PontIndTip,PontIndTip] of UtKatTip;   { kategria-mtrix }

  GrafElekTip2 = record
    Hossz :HosszMtxTip;  { 0 hossz esetn nincs l }
    UtKat :UtKatMtx;
  end;

  TarolTip = (El,Mtx);       { az lek trolsi mdjai }
  KezelTip = (Gr,Kod);       { a kezelsi mdok }

  { grf }
  GrafNevTip = String[8];

  GrafTip = record
    Nev :GrafNevTip;        { ez azonostja majd a hozztartoz adatfjlt is }
    Pontok :GrafPontokTip;  { pontok (ezek trolsa azonos) }
    Elek1 :GrafElekTip1;    { l-trols lek }
    Elek2 :GrafElekTip2;    { mtrix-trols lek }
    Tarol :TarolTip;        { melyik trolsi mdszerrel/lekkel dolgozunk }
    Kezel :KezelTip;        { hogyan kezeljk a grfot }
    VoltMod :Boolean;       { trtnt-e mdosts a legutols ments ta }
  end;

implementation
end.