unit GrafFajl;   { Grf fjlmveletek }

interface

uses Dos, Graph, Szovkez, StandKom, StandInp, StandDef,
     GrAlap, GrKepKom, GrSzKom, GrInp, EgerKez, GrafDekl, GrafKez, GrafGraf;

const
  { A kiajnlhat fjlazonostk maximlis szma }
  MaxFajlDb = 50;
type
  FajlIndTip = 1..MaxFajlDb;
  FajlDbTip = 0..MaxFajlDb;

  FajlNevTip = GrafNevTip;
  FajlKitTip = string[3];
  FajlNevek = array[FajlIndTip] of FajlNevTip;

const
  FajlKit :FajlKitTip = 'NET';

{ a grafikus felleten trtn fjlnv kivlaszts }
function GrFajlNevValaszt(Kit:FajlKitTip; Oszl,Sor:KoordInt;
                          Uzenet:string):FajlNevTip;

{ Grf nevnek bekrse }
procedure GrafNevBe(Szoveg:String; var Nev:GrafNevTip; var Van:Boolean);

{ Az aktulis grf mdostsainak mentst ellenrz eljrs }
procedure MentesEll(var Graf:GrafTip);

{ Az aktulis grf mentse }
procedure Mentes(var Graf:GrafTip);

{ Grf betlts }
procedure Betoltes(var Graf:GrafTip);


implementation

{ A kirs helynek alaprtelmezse (0 koord. esetn) az zenterlet legyen }
procedure AlapErt(var Oszl,Sor:KoordInt);
 begin
  with KeretAdat.Osztas.UzenT do begin
   if Oszl<=0 then Oszl:=O1+2; if Sor<=0 then Sor:=(S1+S2) div 2;
  end;
 end;

function GrFajlNevValaszt(Kit:FajlKitTip; Oszl,Sor:KoordInt;
                          Uzenet:string):FajlNevTip;
const
  UresNev :FajlNevTip = '        ';
  LapDb = 5;
var
  Nevek:FajlNevek;
  Db:FajlDbTip;
  Regi,Uj :FajlIndTip;
  Jel:char;
  Sr:SearchRec;

  { a Nevek tmbbe betltnk max. MaxFajlDb Kit kiterjeszts fjl-nevet }
  { Db: ezek darabszma }
  procedure BeTolt;
  var
    i :FajlDbTip;
    j :Byte;
    Nev :FajlNevTip;
  begin
    Db := 0;
    FindFirst('*.'+Kit, 0, Sr);
    while (DosError = 0) and (Db < MaxFajlDb) do begin
      if Sr.Attr <> Directory then begin
        j := Pos('.', Sr.Name);
        if j> 0 then Nev := JobbTolt(Copy(Sr.Name, 1, j-1), 8)
                else Nev := JobbTolt(Sr.Name, 8);
        { Beszrjuk nvsor szerint a Nevek tmbbe }
        i := Db;
        while (i >= 1) and (Nevek[i] > Nev) do begin
          Nevek[i+1] := Nevek[i];
          Dec(i);
        end;
        Nevek[i+1] := Nev;
        Inc(Db);
      end;
      FindNext(Sr);
    end;
  end;

  { az i. nevet feltlti s fel-, lenyilakkal kiegszti }
  function Kiegeszit(i:FajlIndTip):string;
  var
    Le, Fel :Char;
  begin
    if (i < Db) and (Db >= 2) then Le := #25 else Le := ' ';
    if (i > 1) and (Db >= 2) then Fel := #24 else Fel := ' ';
    Kiegeszit:= Fel + JobbTolt(Nevek[i], Sizeof(FajlNevTip) - 1) + Le;
  end;

  { norml vagy kiemelt szn kirs }
  procedure KiIras(s:string; Normal:Boolean);
  begin
    with KeretAdat.Szinek do
      if Normal then
        GrAlapIr(s, Oszl, Sor, InpBetuSzin, GetBkColor, SolidFill)
      else
        GrAlapIr(s, Oszl, Sor, InpBetuSzin, InpHatSzin, SolidFill);
  end;

begin
  BeTolt;
  EgerKi;
  if Db > 0 then begin
    AlapErt(Oszl, Sor);
    Uj:=1;
    KiIras(Uzenet, True);
    Inc(Oszl, SzovegSzel(Uzenet, DefaultFont, 1) + 1);
    KiIras(Kiegeszit(Uj), False);
    repeat
      Jel := LepesBe;
      Regi := Uj;
      case Jel of
        Bal,Fel    : if Uj > 1 then Dec(Uj, 1);
        LapElo     : if Uj > 1 then
                       if Uj > LapDb then Dec(Uj, LapDb)
                                     else Uj := 1;
        Jobb, Le   : if Uj < Db then Inc(Uj, 1);
        LapKov     : if Uj < Db then
                       if Uj < Db - LapDb then Inc(Uj, LapDb)
                                          else Uj := Db;
        Eleje      : Uj := 1;
        Vege       : Uj := Db;
      end;
      if Uj <> Regi then KiIras(Kiegeszit(Uj), False);
    until Jel in [KiLep,AdatVeg];
    if Jel = KiLep then begin
      GrFajlNevValaszt := '';
      KiIras(' '+UresNev+' ', True);
    end else begin
      GrFajlNevValaszt := JobbVag(Nevek[Uj]);
      KiIras(' '+JobbTolt(Nevek[Uj], Sizeof(FajlNevTip) - 1)+' ', True);
    end
  end else begin
    GrTovabbS('Nincs '+Kit+' kiterjeszts fjl !');
    GrFajlNevValaszt := '';
  end;
  EgerBe;
end;

{ Grf nevnek bekrse }
procedure GrafNevBe(Szoveg:String; var Nev:GrafNevTip; var Van:Boolean);
var
  s :String;
  i :Byte;
begin
  EgerKi;
  s := Nev;
  GrUzenS('');
  GrSzovegBe(Szoveg, s, 0, 0, NagyBetuk+KisBetuk+SzamJegyek,
             1, SizeOf(Nev)-1, [], 0, 0, Van);
  if Van then begin
    { mivel ez lesz a fjl azonostja is nagybetss alaktjuk }
    for i := 1 to Length(s) do
      s[i] := UpCase(s[i]);
    Nev := s;
  end;
  EgerBe;
end;

{ Az aktulis grf mdostsainak mentst ellenrz eljrs }
procedure MentesEll(var Graf:GrafTip);
var
  Valasz :Boolean;
begin
  if Graf.VoltMod then begin
    Valasz := GrIgenValS('A grf mdosult! Mentsk (I/N)');
    GrUzenS('');
    if Valasz then Mentes(Graf);
  end;
end;

{ Az aktulis grf mentse }
procedure Mentes(var Graf:GrafTip);
var
  f :text;
  i,j :PontDbTip;
  l,Db :ElDbTip;
  s :GrafNevTip;
  Van :Boolean;
begin
  with Graf, Pontok do begin
    { NONAME esetn mdosthatjuk a nevet. Ha nem ad meg nevet, nem mentnk }
    if Nev = 'NONAME' then begin
      GrafNevBe('Akt. grf:', Nev, Van);
      if Van then GrFejLecS(Graf);
    end else Van := True;
    if Van then begin
      Assign(f, Nev + '.' + FajlKit);
      ReWrite(f);
      { pontok }
      WriteLn(f, PontDb);
      for i := 1 to PontDb do with Pontok[i] do
        WriteLn(f, Azon, Tip:3, x:13, y:13);
      { lek }
      if Tarol = El then
        with Elek1 do begin
          WriteLn(f, ElDb);
          for i := 1 to PontDb do
            for l := ElMut[i] to ElMut[i+1]-1 do with Elek[l] do
              WriteLn(f, Pontok[i].Azon, ' ', Pontok[VpInd].Azon,
                      Hossz:6, UtKat:3);
      end else
        with Elek2 do begin
          Db := ElSzamol(Hossz, PontDb);
          WriteLn(f, Db);
          for i := 1 to MaxPontDb do
            for j := 1 to MaxPontDb do
              if Hossz[i,j] > 0 then
                WriteLn(f, Pontok[i].Azon, ' ', Pontok[j].Azon,
                        Hossz[i,j]:6, UtKat[i,j]:3);
      end;
      Close(f);
      VoltMod := False;
    end;
  end;
end;

{ Grf betlts }
procedure Betoltes(var Graf:GrafTip);
var
  f :text;
  i, j :0..MaxPontDb+1;
  Kezdo, Veg, ElozoKezdo :PontAzonTip;
  H :ElHossz;
  Kat :UtKatTip;
  l, Db :ElDbTip;
  Van :Boolean;
  Nev :FajlNevTip;
  c :Char;  {az azonostk kztti szkz tlpshez }
  AktEl :ElRekTip;
begin
  MentesEll(Graf);
  Nev := GrFajlNevValaszt(FajlKit, 0, 0, 'A betltend fjl:');
  if Nev <> '' then begin
    GrafInic(Graf);
    Graf.Nev := Nev;
    with Graf, Pontok do begin
      Assign(f, Nev + '.' + FajlKit); Reset(f);
      { pontok }
      ReadLn(f, PontDb);
      for i := 1 to PontDb do with Pontok[i] do
        ReadLn(f, Azon, Tip, x, y);
      { lek }
      if Tarol = El then
        with Elek1 do begin
          ReadLn(f, Db);
          ElDb := 0;
          { kezdlmutatk kezdrtke (egyik pontnak sincs le) }
          for i := 1 to PontDb+1 do ElMut[i] := ElDb+1;
          for l := 1 to Db do begin
            with AktEl do begin
              ReadLn(f, Kezdo, c, Veg, Hossz, UtKat);
              VpInd := PontAzonKeres(Graf, Veg, Van);
            end;
            ElFelvesz(Graf, PontAzonKeres(Graf, Kezdo, Van), AktEl);
          end;
      end else
        with Elek2 do begin
          ReadLn(f, Db);
          for l := 1 to Db do begin
            ReadLn(f, Kezdo, c, Veg, H, Kat);
            i := PontAzonKeres(Graf, Kezdo, Van);
            j := PontAzonKeres(Graf, Veg, Van);
            Hossz[i,j] := H;
            UtKat[i,j] := Kat;
          end;
      end;
      close(f);
    end;
    RajzPar(Graf);
    GrafRajz(Graf);
  end;
end;


end.