unit GrafGraf;    { Grf grafikus eljrsok }

interface

uses
  Graph, StandDef, StandKom,
  GrAlap, GrKepKom, GrSzKom, GrVlKome, EgerKez, GrafDekl, GrafKez;

{ A grf sznei }
type
  GrafSzinTip = record
    Pontok :record
             PontHatter :array[PontTip] of Byte;
             KiemPontHatter, PontKeret, PontAzon :Byte;
            end;
    Elek :record
           Elek :array[UtKatTip] of Byte;
           KiemEl :byte;
          end;
  end;
const
  GrafSzin :GrafSzinTip =
    (Pontok :(PontHatter :(Magenta, Cyan, Green, Brown, LightGray, DarkGray);
              KiemPontHatter :Red; PontKeret :White; PontAzon :Yellow);
     Elek :(Elek :(Cyan, LightGray, LightBlue, LightGreen, LightCyan,
                   LightRed,LightMagenta, Yellow, White);
            KiemEl :Red) );


{ Nhny rajzolsi konstans }
type
  PontMeretTip = (pmMini, pmKicsi, pmKozepes, pmNagy);
const
  { a pontkrk nagysga }
  PontSugar :array[PontMeretTip] of Word = (2, 10, 14, 17);
  { a marg mrete a munkaterleten, tekintettel a pontmretekre s az }
  { lhosszakra, azaz a kezdkpen (ahol nincs vgs) minden ltszdjon }
  Margo = 45;


{ A nagytsos rajzhoz szksges globlis adatok }
type
  KepKeret = record                      { a grafikus kpen lv keret }
    MinX, MaxX, MinY, MaxY : KoordInt;
  end;

  FizKeret = record                    { a minimlis s maximlis }
    MinX, MaxX, MinY, MaxY : Koord;    { koordintk trolshoz  }
  end;

{ A nagytkeret ltal letakart pontok mentshez }
const
  { A 640 x 480-as VGA kpernyt vesszk alapul, hiszen azon }
  { egy 100x100-as ngyzet valban ngyzetnek ltszdik }
  MPDbMax = 2 * (640 + 480);
type
  MPDbTip = 0..MPDbMax;
  MPTip = record
    X, Y :KoordInt;
    Szin :Byte;
  end;
  MPontokTip = array[1..MPDbMax] of MPTip;

  RajzRekTip = record
    RT :KepKeret;              { A rajzterlet }
    NK :KepKeret;              { A nagytkeret helye a kezdkpen }
    MP :MPontokTip;            { A nagytkeret alatti pontok }
    MPDb :MPDbTip;             { A nagytkeret alatti pontok darabszma }
    NSzorzo :Real;             { A nagytsi szorz }
    Szorzo :Real;              { A kezdkpre transzformls szorzja }
    Adat :FizKeret;            { A minimlis s maximlis adat koordintk }
    PontMeret :PontMeretTip;   { Az aktulis pontmret }
    cx, cy :KoordInt;          { A grafikus kurzor pozcija }
  end;

var
  RR :RajzRekTip;   { Az aktulis grfhoz tartoz globlis rajzolsi adatok }


{ Kt pont tvolsga }
function Tav(x1,y1,x2,y2:Koord):Real;

{ Sajt grafikus fejlc, bvtett informcikkal }
procedure GrFejLecS(const Graf:GrafTip);

{ Sajt GrTovabb, hogy az egr ne zavarjon }
procedure GrTovabbS(s:string);

{ Sajt GrUzen, hogy az egr ne zavarjon }
procedure GrUzenS(s:string);

{ Sajt GrIgenVal, hogy az egr ne zavarjon }
function GrIgenValS(s:string):Boolean;

{ Sajt Marker, ami a rajzolsi ablakba teszi a jelet }
procedure MarkerS(x,y:KoordInt);

{ Az eredeti rajz egy pontjnak az aktulis kpre trtn transzformlsa }
procedure KeprePont(x, y:Koord; var xe, ye:KoordInt);

{ Az aktulis kp egy pontjnak visszatranszformlsa az eredeti rajzra }
procedure KeprolPont(xe, ye:KoordInt; var x, y:Koord);

{ Pontmret vlts }
procedure PontMeretValt(const Graf:GrafTip);

{ A rajzolsi paramterek belltsa }
procedure RajzPar(const Graf:GrafTip);

{ A rajzolsi terlet inicializlsa }
procedure RajzTInic;

{ Grf inicializls (res grf + rajzolsi alapbelltsok) }
procedure GrafInic(var Graf:GrafTip);

{ Pont kirajzolsa }
procedure PontRajz(Pont:PontRekTip; Kiemelt:Boolean);

{ l kirajzolsa }
procedure ElRajz(const KPont,VPont:PontRekTip;
                 Hossz:ElHossz; UtKat:UtKatTip; Kiemelt:Boolean);

{ Az aktulis grf kirajzolsa }
procedure GrafRajz(const Graf:GrafTip);

{ A kezdkp kirajzolsa }
procedure KezdoKep(const Graf:GrafTip);

{ Az aktulis kp egy rsznek kinagytsa }
procedure Nagyitas(const Graf:GrafTip);

{ Melyik kpernyn lv pont van legkzelebb az (x0,y0) ponthoz }
procedure LegkozPont(const Graf:GrafTip;
                     x0, y0:KoordInt;
                     var PontInd:PontIndTip;
                     var Van:Boolean);

{ Melyik kpernyn lv l van legkzelebb az (x0,y0) ponthoz }
procedure LegkozEl(const Graf:GrafTip;
                   x0, y0:KoordInt;
                   var KpInd, VpInd:PontIndTip;
                   var Van:Boolean);

{ A rajzolsi ablak be/kikapcsolsa }
procedure RajzAblak(Be, Torles:Boolean);


implementation

{ A rajzolsi ablak be/kikapcsolsa }
{ Ezzel trtnik a nagytott kp lelg rszeinek a levgsa }
procedure RajzAblak(Be, Torles:Boolean);
begin
  if Be then begin
    if Torles then begin
      EgerKi;
      GrMunkaTerTorl;
      EgerBe;
    end;
    { kezdkpnl ne vgjunk, hogy ltszdjanak a szln lv pontkrk }
    with RR, RT do SetViewPort(MinX, MinY, MaxX, MaxY, NSzorzo > 1);
  end else
    { Ekkor a Torles paramternek nincs szerepe }
    SetViewPort(0, 0, GetMaxX, GetMaxY, True);
end;

{ Ponttl adott szgben s tvolsgban lev pont koordintinak kiszmtsa }
procedure PontSzamit(x,y:KoordInt; Tav,Szog:Real; var x1,y1:KoordInt);
begin
  x1 := Round(x + Tav * Cos(Szog));
  y1 := Round(y + Tav * Sin(Szog));
end;

{ Kt pontot sszekt egyenes s az x tengely ltal bezrt szg kiszmtsa }
function SzogSzamit(x1,y1,x2,y2:Integer):Real;
var
  j :Real;
begin
  if x2 = x1 then j := Pi / 2
             else j := ArcTan(Abs(y2 - y1) / Abs(x2 - x1));
  if x1 > x2 then
    if y2 >= y1 then j := Pi - j
                else j := Pi + j
  else
    if y1 > y2  then j := 2 * Pi - j;
  SzogSzamit := j;
end;

function Tav(x1,y1,x2,y2:Koord):Real;
var
  x1r, y1r :Real;
begin
  { valsban, hogy az egszaritmetika ne okozzon hibt }
  x1r := x1; y1r := y1;
  Tav := Sqrt(Sqr(x1r - x2) + Sqr(y1r - y2));
end;

{ Egy pont (x0,y0) s egy szakasz (x1,y1)-(x2,y2) tvolsga }
function PontSzakaszTav(x0,y0,x1,y1,x2,y2:KoordInt):Real;
var
  x, y :KoordInt;
  m, t, t1, t2, t3, x2r, y2r :Real;
begin
  { (x0,y0)-bl az (x1,y1)-(x2,y2) egyenesre merlegest hzunk }
  { meghatrozzuk az (x,y) metszspontot s a tvolsgot (t) }
  if y1 = y2 then begin                                        { vzszintes }
    t := abs(y0 - y1); x := x0; y := y1;
  end else
    if x1 = x2 then begin                                      { fggleges }
      t := abs(x0 - x1); x := x1; y := y0;
    end else begin                                                  { ferde }
      y2r := y2; x2r := x2; m := (y2r - y1) / (x2r - x1);
      x := Round((x0/m + m*x1 - y1 + y0) / (m + 1/m));
      y := Round(y0 - (x - x0)/m);
      t := Tav(x, y, x0, y0);
    end;
  t1 := Tav(x1, y1, x2, y2);                             { a szakasz hossza }
  t2 := Tav(x, y, x1, y1);                { metszspont az egyik vgponttl }
  t3 := Tav(x, y, x2, y2);                             { a msik vgponttl }
  if (t2 <= t1) and (t3 <= t1) then
    { (x,y) a szakaszra esik -> j a tvolsg }
  else begin
    { nem esik r -> a szakaszvgpontoktl vesszk a tvolsgot }
    t2 := Tav(x0, y0, x1, y1);          { (x0,y0) az egyik vgponttl }
    t3 := Tav(x0, y0, x2, y2);                   { a msik vgponttl }
    if t2 < t3 then t := t2 else t := t3;
  end;
  PontSzakaszTav := t;
end;

{ A nagyt transzformci }
function Trafo(Mit:Real; Min:KoordInt):KoordInt;
var
  s :Real;
begin
  s := (Mit - Min) * RR.NSzorzo;
  { Mivel egy grafikus koordinta csak (-MaxInt,MaxInt) -beli lehet }
  if s > MaxInt then s := MaxInt;
  if s < -MaxInt then s:= -MaxInt;
  Trafo := Round(s);
end;

{ Az elbbi eljrs inverze }
function InvTrafo(Mit, Min:KoordInt):Real;
begin
  InvTrafo := Mit / RR.NSzorzo + Min;
end;

{ Az eredeti rajz egy pontjnak az aktulis kpre trtn transzformlsa }
procedure KeprePont(x, y:Koord; var xe, ye:KoordInt);
var
  sx, sy :Real;
begin
  with RR do begin
    { az eredeti koordintkat a kezdkpre }
    sx := Szorzo * (x - Adat.MinX);
    sy := Szorzo * (y - Adat.MinY);

    { nagyts }
    xe := Trafo(sx, NK.MinX);
    { mivel az orig fent vant }
    ye := RT.MaxY - RT.MinY - Trafo(sy, NK.MinY);
  end;
end;

{ Az elbbi eljrs inverze }
procedure KeprolPont(xe, ye:KoordInt; var x, y:Koord);
var
  sx, sy :Real;
begin
  with RR do begin
    sx := InvTrafo(xe, NK.MinX);
    sy := InvTrafo(RT.MaxY - RT.MinY - ye, NK.MinY);
    sx := sx / Szorzo + Adat.MinX;
    sy := sy / Szorzo + Adat.MinY;
    { az esetleges tlcsordulsok miatt }
    if sx > MaxKoord then sx := MaxKoord;
    if sx < MinKoord then sx := MinKoord;
    if sy > MaxKoord then sy := MaxKoord;
    if sy < MinKoord then sy := MinKoord;
    x := Round(sx);
    y := Round(sy);
  end;
end;

{ Az (x,y) pont rajta van-e a rajzterleten }
function PontKepene(x,y:KoordInt):Boolean;
begin
  with RR, RT do
    { mivel a rajzols a rajzterletre nyitott ablakban trtnik }
    PontKepene := (x <= MaxX - MinX) and (x >= 0) and
                  (y <= MaxY - MinY) and (y >= 0);
end;

{ Az adott szakasz rajta van-e a rajzterleten }
function ElKepene(x1,y1,x2,y2: KoordInt):Boolean;
var
  m, b, x, y :Real;
  Rajta :Boolean;
begin
  with RR.RT do
    if PontKepene(x1, y1) or PontKepene(x2, y2) then
      { ha valamelyik vge rajta van }
      Rajta := True
    else
      { egyik vge sincs rajta }
      if x1 = x2 then                                          { fggleges }
        if (x1 >= 0) and (x1 <= MaxX - MinX) then
          { ne egy oldalon lgjanak le }
          if y1 < y2 then
            Rajta := (y1 < 0) and (y2 > MaxY - MinY)
          else Rajta := (y2 < 0) and (y1 > MaxY - MinY)
        else Rajta := False
      else
        if y1 = y2 then                                        { vzszintes }
          if (y1 >= 0) and (y1 <= MaxY - MinY) then
            { ne egy oldalon lgjanak le }
            if x1 < x2 then
              Rajta := (x1 < 0) and (x2 > MaxX - MinX)
            else Rajta := (x2 < 0) and (x2 > MaxX - MinX)
          else Rajta := False
        else begin                                                  { ferde }
          { metszi-e a rajzterlet valamelyik oldalegyenest }
          m := (Round(y1) - y2) / (Round(x1) - x2);
          b := y1 - m * x1;
          { metszi-e az y = 0 egyenest a (0, MaxX - MinX) intervallumban }
          x := - b / m;
          if (x >= 0) and (x <= MaxX - MinX) then
            { ne egy oldalon lgjanak le, azaz a  }
            { metszspont a kt pont kztt van-e }
            if x1 < x2 then
              Rajta := (x >= x1) and (x <= x2)
            else Rajta := (x >= x2) and (x <= x1)
          else begin
            { metszi-e az y = MaxY - MinY egyenest }
            { a (0, MaxX - MinX) intervallumban }
            x := (MaxY - MinY - b) / m;
            if (x >= 0) and (x <= MaxX - MinX) then
              { ne egy oldalon lgjanak le }
              if x1 < x2 then
                Rajta := (x >= x1) and (x <= x2)
              else Rajta := (x >= x2) and (x <= x1)
            else begin
              { metszi-e az x = 0 egyenest a (0, MaxY - MinY) intervallumban }
              y := b;
              if (y >= 0) and (y <= MaxY - MinY) then
                { ne egy oldalon lgjanak le }
                if y1 < y2 then
                  Rajta := (y >= y1) and (y <= y2)
                else Rajta := (y >= y2) and (y <= y1)
              else
                { itt mr nem metszheti az x = MaxX - MinX egyenest sem, }
                { hiszen ha itt 'bejn', akkor az elz hrom oldal egyikn }
                { 'ki is kellett volna mennie', teht elkerli a kpernyt }
                Rajta := False;
            end;
          end;
        end;
  ElKepene := Rajta;
end;

{ A cmet, az aktulis grf nevt, trolsi s kezelsi mdjt a fejlcbe }
procedure GrFejLecS(const Graf:GrafTip);
var
  st :string;
begin
  EgerKi;
  with Graf, KeretAdat, Szinek, Osztas.FejT do begin
    { trls }
    GrAblTorl(O1, S1, O2, S2, GetBkColor, SolidFill);
    { kezels }
    if Kezel = Gr then st := 'Grafikus' else st := 'Kddal';
    GrAltIr('Kezels:' + st, O1+2, (S2+S1) div 2, 0, DefaultFont,
            HorizDir, 1, LeftText, CenterText,
            UzenSzin, GetBkColor, SolidFill);
    { cm+nv }
    if Nev <> '' then st := ' - ' + Nev else st := '';
    GrAltIr(FejLec + st, (O1+O2) div 2, (S2+S1) div 2, 0, DefaultFont,
            HorizDir, 1, CenterText, CenterText,
            FejLecSzin, GetBkColor, SolidFill);
    { trols }
    if Tarol = El then st := 'lenknt' else st := 'Mtrix';
    st := 'Trols:' + st;
    GrAltIr(st, O2-2, (S2+S1) div 2, 0, DefaultFont,
            HorizDir, 1, RightText, CenterText,
            UzenSzin, GetBkColor, SolidFill);
  end;
  EgerBe;
end;

procedure GrTovabbS(s:string);
begin
  EgerKi;
  GrTovabb(s);
  EgerBe;
end;

procedure GrUzenS(s:string);
begin
  EgerKi;
  GrUzen(s);
  EgerBe;
end;

function GrIgenValS(s:string):Boolean;
begin
  EgerKi;
  GrIgenValS := GrIgenVal(s);
  EgerBe;
end;

procedure MarkerS(x,y:KoordInt);
begin
  RajzAblak(True, False);
  if PontKepene(x,y) then CRajz(x, y, False);
  RajzAblak(False, False);
end;

{ A hasznlhat maximlis pontmret meghatrozsa }
function PontMeretMax(const Graf:GrafTip):PontMeretTip;
var
  t, MinT :Real;
  x1, y1, x2, y2 :KoordInt;
  Ok :Boolean;
  i, j :PontDbTip;
  PM :PontMeretTip;
begin
  with Graf, Pontok do
    if PontDb = 0 then
      PontMeretMax := pmNagy
    else begin
      { kt pont kztti legkisebb tvolsg }
      MinT := 1E37;
      for i := 1 to PontDb-1 do
        for j := i+1 to PontDb do begin
          with Pontok[i] do KeprePont(x, y, x1, y1);
          with Pontok[j] do KeprePont(x, y, x2, y2);
          { csak a rajzterletre es pontokat vizsgljuk }
          if PontKepene(x1, y1) and PontKepene(x2, y2) then begin
            t := Tav(x1, y1, x2, y2);
            if t < MinT then MinT := t;
          end;
        end;
      { a lehet legnagyobb pontmret }
      PM := pmNagy;
      Ok := False;
      while not Ok and (PM > pmMini) do
        { 3* :az leknek is hagyunk egy sugrnyi helyet a pontok kztt }
        if 3*PontSugar[PM] <= MinT then Ok := True else Dec(PM);
      PontMeretMax := PM;
    end;
end;

procedure PontMeretValt(const Graf:GrafTip);
var
  PMMax, PM :PontMeretTip;
begin
  with RR do begin
    PMMax := PontMeretMax(Graf);
    PM := PontMeret;
    { PontMeret<=PMMax mindg teljesl, gy PM<>PMMAx esetn PM nvelhet }
    if PM = PMMax then PM := pmMini else Inc(PM);
    if PM = PontMeret then
      { PMMax = pmMini eset }
      GrTovabbS('Nem vltoztathatunk a pontmreten !')
    else begin
      PontMeret := PM;
      GrafRajz(Graf);
    end;
  end;
end;

{ Koordintkat mdost eljrsok utn, de mg azok kirajzolsa eltt }
{ (pl: ponttrls, j grf, betlts, ...) }
procedure RajzPar(const Graf:GrafTip);
var
  XSzorzo, YSzorzo :Real;
  i :PontIndTip;
  PMMax :PontMeretTip;
  RAdat :FizKeret;
begin
  if Graf.Pontok.PontDb = 0 then
    { a koordintk alaprtelmezsben a rajzterletre essenek }
    with RR, Adat do begin
      MaxX := RT.MaxX; MinX := RT.MinX;
      MaxY := RT.MaxY; MinY := RT.MinY;
      { a pontmret alaprtelmezse }
      PontMeret := pmKozepes;
      { nem kell transzformlni }
      Szorzo := 1;
      { ne legyen nagyts }
      with NK do begin
        MinX := 0; MaxX := RT.MaxX - RT.MinX;
        MinY := 0; MaxY := RT.MaxY - RT.MinY;
      end;
      Nszorzo := 1;
  end else
    { a minimlis s maximlis adatkoordintk }
    with RR, Adat do begin
      RAdat := Adat; { megjegyezzk az eddigi hatrokat }
      MaxX := MinKoord; MinX := MaxKoord;
      MaxY := MinKoord; MinY := MaxKoord;
      with Graf, Pontok do
        for i := 1 to PontDb do with Pontok[i] do begin
          if X > MaxX then MaxX := X;
          if X < MinX then MinX := X;
          if Y > MaxY then MaxY := Y;
          if Y < MinY then MinY := Y;
        end;
      if (MaxX <= RT.MaxX) and (MinX >= RT.MinX) and
         (MaxY <= RT.MaxY) and (MinY >= RT.MinY) then begin
        { nem lgunk le a rajzterletrl, }
        { ezrt az adathatr legyen a rajzterlet s ne transzformljunk }
        MaxX := RT.MaxX; MinX := RT.MinX;
        MaxY := RT.MaxY; MinY := RT.MinY;
        Szorzo := 1;
      end else
        { lelgunk a rajzterletrl }
        if (MinX <> RAdat.MinX) or (MaxX <> RAdat.MaxX) or
           (MinY <> RAdat.MinY) or (MaxY <> RAdat.MaxY) then begin
          { megvltozott az adathatr, mdostunk }
          { ne osszunk 0-val, ill. transzformljunk kzpre }
          if MaxX = MinX then MinX := MaxX div 2;
          if MaxY = MinY then MinY := MaxY div 2;
          XSzorzo := (RT.MaxX - RT.MinX) / (MaxX - MinX);
          YSzorzo := (RT.MaxY - RT.MinY) / (MaxY - MinY);
          { a kisebbet vesszk, hogy ne lgjunk le a rajzterletrl }
          if XSzorzo < YSzorzo then Szorzo := XSzorzo
                               else Szorzo := YSzorzo;
          { ne nagytsunk, hogy a vltozst rajzolskor lssuk }
          with NK do begin
            MinX := 0; MaxX := RT.MaxX - RT.MinX;
            MinY := 0; MaxY := RT.MaxY - RT.MinY;
          end;
          Nszorzo := 1;
        end;
      { a pontmretet automatikusan lltjuk, hogy ne rajzoljunk }
      { egymsra pontokat, de ha lehet azrt lssuk ket  }
      PMMax := PontMeretMax(Graf);
      if (PontMeret > PMMax) or (PontMeret = pmMini) then
        PontMeret := PMMAx;
    end;
end;

procedure GrafInic(var Graf:GrafTip);
begin
  GrafAdatTorol(Graf);
  RajzPar(Graf);
end;

procedure RajzTInic;
begin
  with RR, RT, KeretAdat.Osztas.MunkaT do begin
    { a rajzterlet legyen a munkaterlet, margnyi szlekkel }
    MinX := O1 + Margo;  MaxX := O2 - Margo;
    MinY := S1 + Margo;  MaxY := S2 - Margo;
    { a grafikus kurzor elszr a rajzterlet kzeprl induljon }
    cx := (Minx + MaxX) div 2;
    cy := (MinY + MaxY) div 2;
  end;
end;

procedure PontRajz(Pont:PontRekTip; Kiemelt:Boolean);
const
  Betu = DefaultFont;
  MaxBMeret = 10;
var
  BMeret :Word;
  Szin :Byte;
  x1, y1 :KoordInt;
begin
  with Pont do KeprePont(X, Y, x1, y1);
  with GrafSzin.Pontok, Pont, RR do
    if PontKepene(x1, y1) then begin
      RajzAblak(True, False);
      if Kiemelt then Szin := KiemPontHatter else Szin := PontHatter[Tip];
      EgerKi;
      if PontMeret > pmMini then begin
        { kerettel s pontazonostval }
        { betmret meghatrozsa }
        BMeret := 1;
        while (BMeret < MaxBMeret) and (BetuMag(Betu, BMeret+1) <=
              PontSugar[PontMeret]*1.3) do Inc(BMeret);
        SetColor(PontKeret);
        { kr }
        SetFillStyle(SolidFill, Szin);
        FillEllipse(x1, y1, PontSugar[PontMeret], PontSugar[PontMeret]);
        { azonost }
        GrAltIr(Azon, x1, y1, 0, Betu, HorizDir, BMeret, CenterText,
                CenterText, PontAzon, Szin, SolidFill);
      end else begin
        { keret s pontazonost nlkl, hogy az }
        { lnlkli pontok is ltszdjanak }
        SetColor(Szin);
        SetFillStyle(SolidFill, Szin);
        FillEllipse(x1, y1, PontSugar[PontMeret], PontSugar[PontMeret]);
      end;
      RajzAblak(False, False);
      EgerBe;
    end;
end;

procedure ElRajz(const KPont,VPont:PontRekTip;
                 Hossz:ElHossz; UtKat:UtKatTip; Kiemelt:Boolean);
const
  Betu = DefaultFont;
  NyilMeret = 7;
  HelyF = 6;
  HelyV = 3;
var
  Hegy :array[1..3] of PointType;
  kx, ky, vx, vy :KoordInt;
  hx, hy :KoordInt;
  x1, y1, x2, y2 :KoordInt;
  Szog :Real;
  s :String;
  Szin :Byte;
  Tav, FSzel, FMag :KoordInt;
begin
  with KPont do KeprePont(X, Y, x1, y1);
  with VPont do KeprePont(X, Y, x2, y2);
  if ElKepene(x1, y1, x2, y2) then
    with RR do begin
      RajzAblak(True, False);
      { a valdi szg X tengelyre vett tkrkpe mivel az y lefel n }
      Szog := SzogSzamit(x1, y1, x2, y2);
      { a vgpontok koordinti }
      PontSzamit(x1, y1, PontSugar[PontMeret]+1, Szog, kx, ky);
      PontSzamit(x2, y2, PontSugar[PontMeret]+1, Szog+Pi, vx, vy);
      { az lhegy koordinti }
      if PontMeret > pmMini then begin
        PontSzamit(vx, vy, NyilMeret, Szog+Pi-0.4, Hegy[1].x, Hegy[1].y);
        PontSzamit(vx, vy, NyilMeret, Szog+Pi+0.4, Hegy[2].x, Hegy[2].y);
        Hegy[3].x := vx; Hegy[3].y := vy;
      end;
      { a hosszfelirat koordinti }
      { a hossz minl kzelebb legyen az l kzephez, de r ne rjunk }
      Str(Hossz, s);
      FSzel := SzovegSzel(s, Betu, 1) div 2;    { a szvegszlessg fele }
      FMag := BetuMag(Betu, 1) div 2;           { a magassg fele }
      if (Abs(Pi/2 - Szog) < Pi/4) or
         (Abs(3*Pi/2 - Szog) < Pi/4) then begin
        { inkbb fggleges az l (a szlessg dominl) }
        Tav := Round(FMag * Abs(Cos(Szog)/Sin(Szog)));
        Tav := Round(Abs(Sin(Szog)) * (Tav + FSzel + HelyV));
      end else begin
        { inkbb vzszintes az l (a magassg dominl) }
        Tav := Round(FSzel * Abs(Sin(Szog)/Cos(Szog)));
        Tav := Round(Abs(Cos(Szog)) * (Tav + FMag + HelyF));
      end;
      { +Pi/2 kell mert a Szog is tkrkp s az y is lefel n }
      PontSzamit((x1 + x2) div 2, (y1 + y2) div 2, Tav, Szog+Pi/2, hx, hy);
      EgerKi;
      with GrafSzin.Elek do
        if Kiemelt then Szin := KiemEl
        else Szin := Elek[UtKat];
      SetColor(Szin);
      { az l hegye }
      if PontMeret > pmMini then begin
        SetFillStyle(SolidFill, Szin);
        FillPoly(3, Hegy);
      end;
      { vonal }
      Line(kx, ky, vx, vy);
      { hossz }
      if (hx <= 0) or (hy <=0) then MoveTo(hx, hy);
      { mert negatv koordintkra az aktulis grafikus ponttl }
      { (GetX, GetY) kezdden r a GrAltIr eljrs }
      GrAltIr(s, hx, hy, 0, Betu, HorizDir, 1, CenterText, CenterText,
                Szin, GetBkColor, SolidFill);
      RajzAblak(False, False);
      EgerBe;
    end;
end;

procedure GrafRajz(const Graf:GrafTip);
var
  i, j :PontDbTip;
  l :ElDbTip;
begin
  { kirajzols }
  with Graf, Pontok do begin
    { fejlc }
    GrFejLecS(Graf);
    RajzAblak(True, True);
    { pontok }
    for i := 1 to PontDb do PontRajz(Pontok[i], False);
    { lek }
    if Tarol=El then
      with Elek1 do
        for i := 1 to PontDb do
          for l := ElMut[i] to ElMut[i+1]-1 do with Elek[l] do
            ElRajz(Pontok[i], Pontok[VpInd], Hossz, UtKat, False)
    else
      with Elek2 do
        for i := 1 to PontDb do
          for j := 1 to PontDb do
            if Hossz[i,j] > 0 then
              Elrajz(Pontok[i], Pontok[j], Hossz[i,j], UtKat[i,j], False);
  end;
  RajzAblak(False, False);
end;

procedure KezdoKep(const Graf:GrafTip);
begin
  with RR do begin
    { a rajzterlethez relatv nagytkeretet a rajzterlet legszlre }
    with NK do begin
      MinX := 0; MaxX := RT.MaxX - RT.MinX;
      MinY := 0; MaxY := RT.MaxY - RT.MinY;
    end;
    NSzorzo := 1;
    PontMeret := PontMeretMax(Graf);
    GrafRajz(Graf);
  end;
end;

{ Egy pont mentse }
procedure PontMent(px, py:KoordInt);
begin
  { a httrszneket nem mentjk }
  if GetPixel(px, py) <> GetBkColor then
    with RR do begin
      Inc(MPDb);
      with MP[MPDb] do begin
        x := px; y := py; Szin := GetPixel(px, py);
      end;
    end;
end;

{ Az X1,Y1 s X2,Y2 pontokkal adott tglalap alatti pontok mentse }
procedure KeretMent(X1,Y1,X2,Y2 :KoordInt);
var
  i :Integer;
begin
  RR.MPDb := 0;
  for i := X1 to X2 do begin   { vzszintesen }
    PontMent(i, Y1);
    PontMent(i, Y2);
  end;
  for i := Y1 to Y2 do begin   { fgglegesen }
    PontMent(X1, i);
    PontMent(X2, i);
  end;
end;

{ Az elmentett pontok visszalltsa }
procedure KeretVissza;
var
  i :Integer;
begin
  with RR do
    for i := 1 to MPDb do with MP[i] do
      PutPixel(x, y, Szin);
end;

{ A paramterknt kapott nagytkeret mretezse, mozgatsa a rajzterleten }
{ Az eredmny True ha Enter-el lpnk ki, False ha Esc-vel }
function Zoom(var BalX,FelsoY,
                  JobbX,AlsoY:KoordInt):Boolean;
const
  { a mg nem deklarlt billentyk }
  F1 = #59; Ins = #82; Del = #83;
  Nyilak = #32#27#32#24#32#25#32#26#32;
  { a keret szne }
  Szin = White;
  { hny kppontot ugorjon a keret }
  Gyors = 10;
  Lassu = 1;
  { Minimlis keretmret }
  MinMeret = 40;
var
  NovBalX, NovJobbX,                      { a keret megvltozsnak mrtke }
  NovAlsoY, NovFelsoY,
  Seb,                                        { a keretvltozs 'sebessge' }
  BX, JX, FY, AY, dy :KoordInt;                             { segdvltozk }
  Ch :Char;
  Dupla :Boolean;
begin
  Seb := Gyors;
  { A rajzterlet kzepn mr egy kicsinytett kerettel kezdjnk }
  { A nagytkeret a rajzterlet ablakban jelenik meg }
  with RR.RT do begin
    BalX := (MaxX - MinX) div 4;
    JobbX := MaxX - MinX - BalX;
    FelsoY := (MaxY - MinY) div 4;
    AlsoY := MaxY - MinY - FelsoY;
  end;
  EgerKi;
  { A hasznlhat billentyk }
  GrUzenS('Keret: Ins, Del, Nyilak, F1    Befejezs: Enter, Esc');
  RajzAblak(True, False);
  KeretMent(BalX, FelsoY, JobbX, AlsoY);
  SetColor(Szin);
  Rectangle(BalX, FelsoY, JobbX, AlsoY);
  repeat
    NovBalX := 0; NovJobbX := 0; NovFelsoY := 0; NovAlsoY := 0;
    Ch := BillBe([Valaszt,KiLep], [Fel,Le,Jobb,Bal,Ins,Del,F1],Dupla);
    case Ch of
      Fel  :begin NovFelsoY := -Seb; NovAlsoY := -Seb; end;
      Le   :begin NovFelsoY := Seb;  NovAlsoY := Seb;  end;
      Bal  :begin NovBalX := -Seb;   NovJobbX := -Seb; end;
      Jobb :begin NovBalX := Seb;    NovJobbX := Seb;  end;
      Ins  :begin               { nagyits }
              NovBalX := -2*Seb; NovJobbX := 2*Seb;
              { hogy a tglalap mretarnyos maradjon }
              with RR.RT do
                dy := Round((MaxY - MinY) / (MaxX - MinX) *
                            (JobbX - BalX + 4*Seb) - (AlsoY - FelsoY)) div 2;
              NovFelsoY := -dy; NovAlsoY := dy;
            end;
      Del  :begin               { kicsinyits }
              NovBalX := 2*Seb; NovJobbX := -2*Seb;
              with RR.RT do
                dy := Round(AlsoY - FelsoY - (MaxY - MinY) / (MaxX - MinX) *
                            (JobbX - BalX - 4*Seb)) div 2;
              NovFelsoY := dy; NovAlsoY := -dy;
            end;
      f1   :if Seb = Gyors      { sebessgvlts }
            then Seb := Lassu else Seb:=gyors;
    end;
    if Ch in [Fel,Le,Bal,Jobb,Ins,Del] then begin
      BX := BalX + NovBalX;  JX := JobbX + NovJobbX;
      FY := FelsoY + NovFelsoY;  AY := AlsoY + NovAlsoY;
      { nem lg-e le, vagy nem tl kicsi-e a kvnt nagytkeret }
      with RR.RT do
        if not ( (BX < 0) or (JX > MaxX - MinX) or
                 (BX + MinMeret > JX) or
                 (FY < 0) or (AY > MaxY - MinY) ) then begin
          { j a kvnt keret }
          { az elz hely visszalltsa }
          SetColor(GetBkColor);
          Rectangle(BalX, FelsoY, JobbX, AlsoY);
          { hiszen csak a nem httrszn pontokat mentettk el }
          KeretVissza;
          { az j keret kiraksa }
          KeretMent(BX, FY, JX, AY);
          BalX := BX; JobbX := JX; FelsoY := FY; AlsoY := AY;
          SetColor(Szin);
          Rectangle(BalX, FelsoY, JobbX, AlsoY);
        end;
    end;
  until Ch in [Valaszt,KiLep];
  { 'levesszk' a keretet }
  SetColor(GetBkColor);
  Rectangle(BalX, FelsoY, JobbX, AlsoY);
  KeretVissza;
  RajzAblak(False, False);
  EgerBe;
  Zoom := Ch = Valaszt;
end;

procedure Nagyitas(const Graf:GrafTip);
const
  { a maximlis nagytshoz: ennl kisebb nem lehet }
  { a kezdkpen lv nagytkeret }
  MinElt = 5;
var
  BalX, FelsoY, JobbX, AlsoY :KoordInt;
  PM :PontMeretTip;
begin
  with RR, NK do
    if Zoom(BalX, FelsoY, JobbX, AlsoY) then begin
      if Round(InvTrafo(BalX, MinX)) + MinELt >=
         Round(InvTrafo(JobbX, MinX)) then
        { Igen nagy nagyts esetre }
        GrTovabbS('Tl nagy nagyts ! Nem nagytunk !')
      else begin
        { keret helye a kezdkpen }
        { elbb a max-okat szmoljuk ki, mert ahhoz kellenek a rgi min-ok }
        MaxX := Round(InvTrafo(JobbX, MinX));
        MinX := Round(InvTrafo(BalX, MinX));
        MaxY := Round(InvTrafo(RT.MaxY - RT.MinY - FelsoY, MinY));
        MinY := Round(InvTrafo(RT.MaxY - RT.MinY - AlsoY, MinY));
        NSzorzo := (RT.MaxX - RT.MinX) / (MaxX - MinX);
        { pontmret }
        PM := PontMeretMax(Graf);
        if (PM > pmMini) and (PontMeret = pmMini) then
          PontMeret := PM;
        GrafRajz(Graf);
      end;
    end;
end;

procedure LegkozPont(const Graf:GrafTip;
                     x0, y0:KoordInt;
                     var PontInd:PontIndTip;
                     var Van:Boolean);
var
  x1, y1 :KoordInt;
  t, MinT :Real;
  i :PontIndTip;
begin
  MinT := 1E37;
  Van := False;
  with Graf, Pontok do
    for i := 1 to PontDb do begin
      with Pontok[i] do KeprePont(X, Y, x1, y1);
      { csak a kpen lv pontok jhetnek szba }
      if PontKepene(x1, y1) then begin
        Van := True;
        t := Tav(x0, y0, x1, y1);
        if t < MinT then begin
          MinT := t; PontInd := i;
        end;
      end;
    end;
end;

procedure LegkozEl(const Graf:GrafTip;
                   x0, y0:KoordInt;
                   var KpInd, VpInd:PontIndTip;
                   var Van:Boolean);
var
  x1, y1, x2, y2 :KoordInt;
  t, MinT :Real;
  i :PontIndTip;
  j :ElDbTip;
begin
  MinT := 1E37;
  Van := False;
  with Graf, Pontok do
    if Tarol = El then
      with Elek1 do
        for i := 1 to PontDb do
          for j := ElMut[i] to ElMut[i+1]-1 do begin
            with Pontok[i] do KeprePont(X, Y, x1, y1);
            with Pontok[Elek[j].VpInd] do KeprePont(X, Y, x2, y2);
            if ElKepene(x1, y1, x2, y2) then begin
              { csak a kpen lv lek jhetnek szba }
              Van := True;
              t := PontSzakaszTav(x0, y0, x1, y1, x2, y2);
              if t < MinT then begin
                MinT := t; KpInd := i; VpInd := Elek[j].VpInd;
              end;
            end;
          end
    else
      with Elek2 do
        for i := 1 to MaxPontDb do
          for j := 1 to MaxPontDb do
            if Hossz[i,j] > 0 then begin
              with Pontok[i] do KeprePont(X, Y, x1, y1);
              with Pontok[j] do KeprePont(X, Y, x2, y2);
              if ElKepene(x1, y1, x2, y2) then begin
                { csak a kpen lv lek jhetnek szba }
                Van := True;
                t := PontSzakaszTav(x0, y0, x1, y1, x2, y2);
                if t < MinT then begin
                  MinT := t; KpInd := i; VpInd := j;
                end;
              end;
            end;
end;

end.
