unit GrafKez;      { Grf kezel eljrsok }

interface

uses GrafDekl;

{ Pont (vagy a helynek) keresse azonost alapjn }
function PontAzonKeres(const Graf:GrafTip; PontAzon:PontAzonTip;
                       var Van:Boolean):PontIndTip;

{ Pont felvtele a Grfba }
procedure PontFelvesz(var Graf:Graftip; Pont:PontRekTip);

{ Pont trlse a Grf-bl (az leivel egytt) }
procedure PontTorol(var Graf:GrafTip; PontInd:PontIndTip);


{ ltrolsos esethez }

{ l (vagy a helynek) keresse pontindexek alapjn }
function ElKeres(const Graf:GrafTip; KpInd,VpInd:PontIndTip;
                 var Van:Boolean):ElIndTip;

{ l felvtele }
procedure ElFelvesz(var Graf:GrafTip; KpInd:PontIndTip; const El:ElRekTip);

{ l trlse }
procedure ElTorol(var Graf:GrafTip; KpInd,VpInd:PontIndTip);


{ Mtrixos trolshoz }

{ lek szma }
function ElSzamol(const Hossz:HosszMtxTip; PontDb:PontDbTip):ElDbTip;


{ Grf adatainak trlse }
procedure GrafAdatTorol(var Graf:GrafTip);

{ Adatkonverzi1: Mtrix -> lenknti }
procedure Konverzio1(var Graf:GrafTip);

{ Adatkonverzi2: lenknti -> Mtrix }
procedure Konverzio2(var Graf:GrafTip);


implementation


function PontAzonKeres(const Graf:GrafTip; PontAzon:PontAzonTip;
                       var Van:Boolean):PontIndTip;
{ PontDb = MaxPontDb esetn csak meglv elemet fogunk keresni, }
{ gy az eredmny mindig PontIndTip lesz (s sose kapunk MaxPontDb+1-t) }
var
  E, V, Hol :PontDbTip;
begin
  with Graf.Pontok do begin
    E := 1; V := PontDb; Van := False;
    while (E <= V) and not Van do
      begin
        Hol := (E + V) div 2;
        Van := Pontok[Hol].Azon = PontAzon;
        if not Van then
          if Pontok[Hol].Azon < PontAzon then  E := Hol + 1
                                         else  V := Hol - 1;
      end;
  end;
  if not Van then Hol:=E;
  PontAzonKeres := Hol;
end;

procedure PontFelvesz(var Graf:Graftip; Pont:PontRekTip);
var
  PontInd :PontIndTip;
  i, j :0..MaxPontDb+1;
  Van :Boolean;
  l :ElDbTip;
begin
  with Graf, Pontok do begin
    { a pont helynek megkeresse }
    PontInd := PontAzonKeres(Graf, Pont.Azon, Van);
    { lek kezelse }
    if Tarol = El then
      with Elek1 do begin
        { az innentl indul pontokra mutat lek vgpontindexeinek nvelse }
        for l := 1 to ElDb do with Elek[l] do
          if VpInd >= PontInd then Inc(VpInd);
        { helykszts az lmutat tmbben }
        for i := PontDb+1 downto PontInd do
          ElMut[i+1] := ElMut[i];
        { ezutn ElMut[PontInd] = ElMut[PontInd+1] lesz, ami ppen az, }
        { hogy az j pontnak (ami a PontInd helyre kerl) mg nincs le }
    end else
      with Elek2 do begin
        { helykszts a mtrixokban az j pont leinek }
        for i := PontDb downto PontInd do  { sorok }
          for j := 1 to PontDb do begin
            Hossz[i+1,j] := Hossz[i,j];
            UtKat[i+1,j] := Utkat[i,j];
          end;
        for j := PontDb downto PontInd do  { oszlopok }
          for i := 1 to PontDb+1 do begin
            Hossz[i,j+1] := Hossz[i,j];
            UtKat[i,j+1] := Utkat[i,j];
          end;
        for i := 1 to PontDb+1 do begin    { az j pont leinek }
          Hossz[i,PontInd] := 0;
          UtKat[i,PontInd] := 1;
          Hossz[PontInd,i] := 0;
          UtKat[PontInd,i] := 1;
        end;
      end;
    { pontvelvtel }
    for i := PontDb downto PontInd do                        { helykszts }
      Pontok[i+1] := Pontok[i];
    Pontok[PontInd] := Pont;                                     { felvtel }
    Inc(PontDb);                                                  { db szm }
  end;
end;

procedure PontTorol(var Graf:GrafTip; PontInd:PontIndTip);
var
  i, j :PontIndTip1; l :0..MaxElDb+1;
begin
  with Graf, Pontok do begin
    { lei }
    if Tarol = El then
      with Elek1 do begin
        while ElMut[PontInd] < ElMut[PontInd+1] do       { a belle indulk }
          ElTorol(Graf, PontInd, Elek[ElMut[PontInd]].VpInd);
        for i := 1 to PontDb do begin                        { a bel jvk }
          l := ElMut[i];
          while l < ElMut[i+1] do with Elek[l] do
            if VpInd = PontInd then ElTorol(Graf, i, VpInd)
            else Inc(l);
        end;
        { a mgtte lv pontokra mutat lek vgpontindexeinek cskkentse }
        for l := 1 to ElDb do with Elek[l] do
          if VpInd > PontInd then Dec(VpInd);
        { az lmutat tmbbl is trljk a PontInd. elemet }
        for i := PontInd to PontDb do
          ElMut[i] := ElMut[i+1];
    end else
      with Elek2 do begin                  { elremsols }
        for i := PontInd+1 to PontDb do    { sorok }
          for j := 1 to PontDb do begin
            Hossz[i-1,j] := Hossz[i,j];
            UtKat[i-1,j] := Utkat[i,j];
          end;
        for j := PontInd+1 to PontDb do    { oszlopok }
          for i := 1 to PontDb do begin
            Hossz[i,j-1] := Hossz[i,j];
            UtKat[i,j-1] := Utkat[i,j];
          end;
      end;
    { pont }
    for i := PontInd+1 to PontDb do                  { pontok elremsolsa }
      Pontok[i-1] := Pontok[i];
    Dec(PontDb);                                                  { db szm }
  end;
end;

function ElKeres(const Graf:GrafTip; KpInd,VpInd:PontIndTip;
                 var Van:Boolean):ElIndTip;
var
  E, V, Hol :ElDbTip;
begin
  { Az indexek szerinti sorend az azonost szerinti sorrendnek felel meg, }
  { hiszen a pontok azonost szerint rendezettek, gy az indexek alapjn }
  { binrisan kereshetnk az adott kezdpont pont lei kztt. }
  { Nem kaphatunk MaxElDb+1 -t eredmnyl, hiszen ElDb = MaxElDb esetn }
  { mr csak meglv leket keresnk. }
  with Graf, Pontok, Elek1 do begin
    E := ElMut[KpInd];
    V := ElMut[KpInd+1]-1;
    Van := False;
    while (E <= V) and not Van do
      begin
        Hol := (E + V) div 2;
        Van := Elek[Hol].VpInd = VpInd;
        if not Van then
          if Elek[Hol].VpInd < VpInd
            then  E := Hol + 1
            else  V := Hol - 1;
      end;
    if not Van then Hol:=E;
  end;
  ElKeres := Hol;
end;

procedure ElFelvesz(var Graf:GrafTip; KpInd:PontIndTip; const El:ElRekTip);
var
  ElInd :ElIndTip;
  l :ElDbTip;
  i :PontIndTip1;
  Van :Boolean;
begin
  with Graf, Pontok, Elek1 do begin
    ElInd := ElKeres(Graf, KpInd, El.VpInd, Van);             { az l helye }
    for i := KpInd+1 to PontDb+1 do                    { lmutatk nvelse }
      Inc(ElMut[i]);
    for l := ElDb downto ElInd do                            { helykszts }
      Elek[l+1] := Elek[l];
    Elek[ElInd] := El;                                           { felvtel }
    Inc(ElDb);                                                    { db szm }
  end;
end;

procedure ElTorol(var Graf:GrafTip; KpInd,VpInd:PontIndTip);
var
  ElInd, l :ElIndTip;
  i :PontIndTip1;
  Van :Boolean;
begin
  ElInd := ElKeres(Graf, KpInd, VpInd, Van);                  { az l helye }
  with Graf, Pontok, Elek1 do begin
    for i := KpInd+1 to PontDb+1 do                 { lmutatk cskkentse }
      Dec(ElMut[i]);
    for l := ElInd+1 to Eldb do                  { ltrls elremsolssal }
      Elek[l-1] := Elek[l];
    Dec(ElDb);                                                    { db szm }
  end;
end;

function ElSzamol(const Hossz:HosszMtxTip; PontDb:PontDbTip):ElDbTip;
var
  Db :ElDbTip;
  i, j :PontDbTip;
begin
  Db := 0;
  for i := 1 to PontDb do
    for j := 1 to PontDb do
      if Hossz[i,j] > 0 then Inc(Db);             { 0 hossz esetn nincs l }
  ElSzamol := Db;
end;

procedure GrafAdatTorol(var Graf:GrafTip);
var
  i, j :PontIndTip;
begin
  with Graf, Pontok, Elek1, Elek2 do begin
    Nev := '';
    VoltMod := False;
    PontDb := 0;
    {l-trols}
    ElDb := 0;
    { az utols pont leinek vghez }
    ElMut[PontDb+1] := ElDb+1;
    {mtrix-trols}
    for i:=1 to MaxPontDb do
      for j:=1 to MaxPontDb do begin
        Hossz[i,j] := 0;
        { a mtx-ban j rtk legyen mindenhol }
        UtKat[i,j] := 1;
      end;
  end;
end;

{ Mtrix -> lenknti }
procedure Konverzio1(var Graf:GrafTip);
var
  i, j :PontDbTip;
  Db :ElDbTip;
  ElsoEl :Boolean;
begin
  { Mivel a pontok trolsa azonos, gy csak az leket konvertljuk.  }
  { Az eredmny lek a megfelel mdon (kezdpont, azon bell vgpont }
  { szerint) rendezettek lesznek, hiszen a mtrix i. sora/oszlopa az  }
  { azonost szerinti i. pont leit tartalmazza. }
  with Graf, Pontok, Elek1, Elek2 do begin
    Db := 0;
    for i := 1 to PontDb do begin
      ElsoEl := True;
      for j := 1 to PontDb do
        if Hossz[i,j] > 0 then begin
          Inc(Db);
          Elek[Db].VpInd := j;
          Elek[Db].Hossz := Hossz[i,j];
          Elek[Db].Utkat := UtKat[i,j];
          { az els lekre mutat indexek }
          if ElsoEL then begin
            ElMut[i] := Db;
            ElsoEl := False;
          end;
        end;
      if ElsoEL then { nem volt belle kimen l }
        ElMut[i] := Db+1;
    end;
    ElDb := Db;
    ElMut[PontDb+1] := Db+1;
    Tarol := El;
  end;
end;

{ lenknti -> Mtrix }
procedure Konverzio2(var Graf:GrafTip);
var
  i, j :PontDbTip;
  l :ElDbTip;
  Van :Boolean;
begin
  with Graf, Pontok, Elek1, Elek2 do begin
    { az lmtrix-ban ne legyen l }
    for i := 1 to PontDb do
      for j := 1 to PontDb do begin
        Hossz[i,j] := 0;
        { a kategria mtrixban ne legyen rvnytelen adat }
        UtKat[i,j] := 1;
      end;
    for i := 1 to PontDb do
      for l := ElMut[i] to ElMut[i+1]-1 do with Elek[l] do begin
        Elek2.Hossz[i,VpInd] := Hossz;
        Elek2.UtKat[i,VpInd] := UtKat;
    end;
    Tarol := Mtx;
  end;
end;

end.