unit GrafMFFa;      { Grf minimlis fesztfa algoritmus }

interface

uses Graph, EgerKez, GrafDekl, GrafKez, GrafGraf, GrafMod;

type
  { egy l helye az lhalmazokban }
  ElHelyTip = (Eben, Fben, Sehol);
  ElHelyTomb = array[ElIndTip] of ElHelyTip;
  ElHelyMtx = array[PontIndTip,PontIndTip] of ElhelyTip;

  { egy pont helye a H-ban (H ilyen sorszm halmazban van az adott pont) }
  PontHelyTip = PontIndTip;
  PontHelyek = array[PontIndTip] of PontHelyTip;

  { a minimlis fesztfhoz }
  FaElTip = record
              Kp, Vp :PontIndTip;
              Hossz :ElHossz;
            end;
  FaTip = array[ElIndTip] of FaElTip;
  FaElDbTip = ElDbTip;


{ Minimlis fesztfa, komponensekre bonts }
procedure FeszitoFa(var Graf:GrafTip);


implementation

{ A grf talaktsa gy, hogy minden l ktirnyban egyforma legyen }
procedure Alakit(var Graf:GrafTip);
var
  Poz1, Poz2 :ElIndTip;
  i, j :PontIndTip;
  UjEl :ElRekTip;
  ElVan1, ElVan2 :Boolean;
begin
  with Graf, Pontok do begin
    { a hinyz lprt felvesszk ugyanolyan hosszal s kategrival, }
    { mg a meglv lprnak csak a hosszt 'igaztjuk' ugyanakkorra }
    if Tarol = El then begin
      with Elek1 do
        for i := 1 to PontDb do
          for j := 1 to PontDb do
            if j <> i then begin
              Poz1 := ElKeres(Graf, i, j, ElVan1);
              Poz2 := ElKeres(Graf, j, i, ElVan2);
              if ElVan1 and ElVan2 then
                Elek[Poz1].Hossz := Elek[Poz2].Hossz
              else
                if ElVan1 then begin                   { j->i l }
                  UjEl.VpInd := i;
                  UjEl.Hossz := Elek[Poz1].Hossz;
                  UjEl.UtKat := Elek[Poz1].UtKat;
                  ElFelvesz(Graf, j, UjEl);
                end else
                  if ElVan2 then begin                 { i->j l }
                    UjEl.VpInd := j;
                    UjEl.Hossz := Elek[Poz2].Hossz;
                    UjEl.UtKat := Elek[Poz2].UtKat;
                    ElFelvesz(Graf, i, UjEl);
                  end;
            end;
    end else
      with Elek2 do
        for i := 1 to PontDb do
          for j := 1 to PontDb do
            if Hossz[i,j] > 0 then begin
              if Hossz[j,i] = 0 then
                UtKat[j,i] := UtKat[i,j];
              Hossz[j,i] := Hossz[i,j];
            end;
    VoltMod := True;
  end;
end;

{ A grf vizsglata, hogy minden l ktirny s egyforma hossz-e }
procedure Vizsgal(var Graf:GrafTip; var OK:Boolean);
var
  l :ElDbTip;
  Poz :ElIndTip;
  i, j :PontIndTip;
  UjEl :ElRekTip;
  ElVan :Boolean;
begin
  OK := True;
  with Graf, Pontok do
    if Tarol = El then
      with Elek1 do begin
        if ElDb > 0 then
          for i := 1 to PontDb do
            for l := ElMut[i] to ElMut[i+1]-1 do
              with Elek[l] do begin
                Poz := ElKeres(Graf, VpInd, i, ElVan);
                if ElVan then begin
                  if Elek[Poz].Hossz <> Hossz then OK := False;
                end else OK := False;
              end
      end
    else
      with Elek2 do
        for i := 1 to PontDb do
          for j := 1 to PontDb do
            if Hossz[i,j] <> Hossz[j,i] then OK := False;
end;

{ A minimlis fesztfa meghatrozsa }
procedure MinFFa(const Graf:GrafTip; var Osszefuggo:Boolean;
                 var F:FaTip; var FDb:FaElDbTip);
var
  l :ElDbTip;
  HDb, X, Y, i, j :PontIndTip;
  EDb, MinInd, MinInd1, MinInd2 :ElDbTip;
  H :PontHelyek;
  E1 :ElHelyTomb;
  E2 :ElHelyMtx;
  A ,B :PontHelyTip;
begin
  with Graf, Pontok do begin
    { Kezdllapot }
    { E-be minden lt }
    if Tarol = El then
      with Elek1 do begin
        for l := 1 to ElDb do E1[l] := Eben;
        EDb := ElDb;
      end
    else begin
      EDb := 0;
      with Elek2 do
        for i := 1 to PontDb do
          for j := 1 to PontDb do
            if Hossz[i,j] > 0 then begin
              E2[i,j] := Eben;
              Inc(EDb);
            end;
    end;
    { F legyen res }
    FDb := 0;
    { H-ba minden pontot mint egyelem rszhalmazokat }
    for i := 1 to PontDb do H[i] := i;
    HDb := PontDb;
    { Javt lpsek }
    while (HDB > 1) and (EDb > 0) do begin
      if Tarol = El then begin
        MinInd := 0;
        with Elek1 do
          for i := 1 to PontDb do
            for l := ElMut[i] to ElMut[i+1]-1 do
              with Elek[l] do
                if (E1[l] = Eben) and
                   ((MinInd = 0) or
                    (Hossz < Elek[MinInd].Hossz)) then begin
                  X := i;
                  Y := VpInd;
                  MinInd := l;
                end;
      end else
        with Elek2 do begin
          MinInd1 := 0;
          for i := 1 to PontDb do
            for j := 1 to PontDb do
              if (Hossz[i,j] > 0) and
                 (E2[i,j] = Eben) and
                 ((MinInd1 = 0) or
                  (Hossz[i,j] < Hossz[MinInd1,MinInd2])) then begin
                X := i;
                Y := j;
                MinInd1 := i;
                MinInd2 := j;
              end;
        end;
      if H[X] <> H[Y] then begin   { klnbz halmazba esnek -> egyestnk }
        { a kisebb sorszm halmazba (A) tesszk valamennyit, }
        { a nagyobb sorszm halmazt (B) pedig trljk az utols }
        { ponthalmaz elemeinek ebbe a halmazba val tsorolsval }
        if H[X] < H[Y] then begin
          A := H[X]; B := H[Y];
        end else begin
          A := H[Y]; B := H[X];
        end;
        for i := 1 to PontDb do
          if H[i] = B then H[i] := A
          else if H[i] = HDb then H[i] := B;
        Dec(HDb);
        { X-Y lt F-be }
        if Tarol = El then E1[MinInd] := Fben
        else E2[MinInd1,MinInd2] := Fben;
        Inc(FDb);
        with F[FDb] do begin
          Kp := X; Vp := Y;
          if Tarol = El then Hossz := Elek1.Elek[MinInd].Hossz
          else Hossz := Elek2.Hossz[MinInd1,MinInd2];
        end;
      end else                { az lvgpontok nem esnek klnbz halmazba }
        if Tarol = El then E1[MinInd] := Sehol
        else E2[MinInd1,MinInd2] := Sehol;
      Dec(EDb);
    end;
    Osszefuggo := HDb = 1;
  end;
end;

{ A grf komponensekre bontsa }
procedure KompBont(const Graf:GrafTip;
                   var H :PontHelyek; var HDb :PontIndTip);
var
  l :ElDbTip;
  X, Y, i, j :PontIndTip;
  EDb, MinInd, MinInd1, MinInd2 :ElDbTip;
  E1 :ElHelyTomb;
  E2 :ElHelyMtx;
  A ,B :PontHelyTip;
begin
  with Graf, Pontok do begin
    { Kezdllapot }
    { E-be minden lt }
    if Tarol = El then
      with Elek1 do begin
        for l := 1 to ElDb do E1[l] := Eben;
        EDb := ElDb;
      end
    else begin
      EDb := 0;
      with Elek2 do
        for i := 1 to PontDb do
          for j := 1 to PontDb do
            if Hossz[i,j] > 0 then begin
              E2[i,j] := Eben;
              Inc(EDb);
            end;
    end;
    { H-ba minden pontot mint egyelem rszhalmazokat }
    for i := 1 to PontDb do H[i] := i;
    HDb := PontDb;
    { Javt lpsek }
    while (HDB > 1) and (EDb > 0) do begin
      if Tarol = El then begin
        MinInd := 0;
        i := 1;
        with Elek1 do
          while (i <= PontDb) and (MinInd = 0) do begin
            l := ElMut[i];
            while (l <= ElMut[i+1]-1) and (MinInd = 0) do
              with Elek[l] do
                if E1[l] = Eben then begin
                  X := i;
                  Y := VpInd;
                  MinInd := l
                end else Inc(l);
            Inc(i);
          end;
      end else
        with Elek2 do begin
          MinInd1 := 0;
          i := 1;
          while (i <= PontDb) and (MinInd1 = 0) do begin
            j := 1;
            while (j <= PontDb) and (MinInd1 = 0) do
              if (Hossz[i,j] > 0) and
                 (E2[i,j] = Eben) then begin
                X := i;
                Y := j;
                MinInd1 := i;
                MinInd2 := j;
              end else Inc(j);
            Inc(i);
          end;
        end;
      if H[X] <> H[Y] then begin   { klnbz halmazba esnek -> egyestnk }
        { a kisebb sorszm halmazba (A) tesszk valamennyit, }
        { a nagyobb sorszm halmazt (B) pedig trljk az utols }
        { ponthalmaz elemeinek ebbe a halmazba val tsorolsval }
        if H[X] < H[Y] then begin
          A := H[X]; B := H[Y];
        end else begin
          A := H[Y]; B := H[X];
        end;
        for i := 1 to PontDb do
          if H[i] = B then H[i] := A
          else if H[i] = HDb then H[i] := B;
        Dec(HDb);
        { X-Y lt F-be }
        if Tarol = El then E1[MinInd] := Fben
        else E2[MinInd1,MinInd2] := Fben;
      end else                { az lvgpontok nem esnek klnbz halmazba }
        if Tarol = El then E1[MinInd] := Sehol
        else E2[MinInd1,MinInd2] := Sehol;
      Dec(EDb);
    end;
  end;
end;

{ Minimlis fesztfa, komponensekre bonts }
procedure FeszitoFa(var Graf:GrafTip);
var
  i, j, HDb :PontIndTip;
  H :PontHelyek;
  Db :PontDbTip;
  Fa :FaTip;
  l, FaElDb :FaElDbTip;
  OsszHossz :Longint;
  kx, ky, vx, vy :KoordInt;
  x1, y1, x2, y2 :KoordInt;
  Szog :Real;
  Szin :Byte;
  st, s :String;
  OK :Boolean;
begin
  if Graf.Pontok.Pontdb > 0 then begin
    Vizsgal(Graf, OK);
    if not OK and
       GrIgenValS('A grf nem megfelel ! talaktsuk (I/N)') then begin
      Alakit(Graf);
      GrafRajz(Graf);
      OK := True;
    end;
    if OK then
      with Graf, Pontok do begin
        MinFFa(Graf, OK, Fa, FaElDb);
        if not OK then begin
          if GrIgenValS('A grf nem sszefgg !'+
                        ' Bontsuk komponensekre (I/N)') then begin
            KompBont(Graf, H, HDb);
            { a grf sszefgg komponenseinek kiemelse }
            for i := 1 to HDb do begin
              Db := 0;
              for j := 1 to PontDb do
                if H[j] = i then begin
                  PontRajz(Pontok[j], True);
                  Inc(Db);
                end;
              Str(i, st); Str(Db, s);
              GrTovabbS(st+'. komponens '+s+' db pontbl ll.');
              { megszntetjk a kiemelst }
              for j := 1 to PontDb do
                if H[j] = i then
                  PontRajz(Pontok[j], False);
            end;
          end;
        end else begin
          { a fesztfa kirajzolsa, sszhossznak kiszmtsa }
          EgerKi;
          RajzAblak(True, False);
          OsszHossz := 0;
          for l := 1 to FaElDb do
            with Fa[l] do begin
              { UtKat mindegy, hiszen kiemelnk }
              ElRajz(Pontok[Kp], Pontok[Vp], Hossz, MaxUtKat, True);
              { mindkt irnyt kiemeljk }
              ElRajz(Pontok[Vp], Pontok[Kp], Hossz, MaxUtKat, True);
              Inc(OsszHossz, Hossz);
            end;
          RajzAblak(False, False);
          Str(OsszHossz, s);
          GrTovabbS('A minimlis fesztfa sszhossza:'+s);
          { 'eltntetjk' a fesztft }
          GrafRajz(Graf);
          EgerBe;
        end;
      end;
  end else GrTovabbS('Nincs felvve pont !');
end;

end.