unit GrafMod;      { Grf mdost eljrsok }

interface

uses Graph, StandDef, GrAlap, GrSzKom, GrKepKom, GrVlKome, GrInp, EgerKez,
     GrafDekl, GrafKez, GrafGraf, GrafFajl;


{ Pontvlaszts azonost alapjn vagy egrrel }
function PontValaszt(const Graf:GrafTip; Szoveg:String;
                     var PontInd:PontIndTip):Boolean;

{ Pontinformci }
procedure PontInf(const Graf:GrafTip);

{ Uj pont felvtele }
procedure PontFelvitel(var Graf:GrafTip);

{ Pont trlse }
procedure PontTorles(var Graf:GrafTip);

{ Pont mdostsa }
procedure PontMod(var Graf:GrafTip);

{ A k. pontbl a v. pontba men l adatai }
procedure ElAdatok(const Graf:GrafTip; k,v:PontIndTip;
                   var h:ElHossz; var Kat:UtKatTip);

{ linformci }
procedure ElInf(const Graf:GrafTip);

{ Uj l felvtele }
procedure ElFelvitel(var Graf:GrafTip);

{ l trlse }
procedure ElTorles(var Graf:GrafTip);

{ l mdostsa  }
procedure ElMod(var Graf:GrafTip);

{ Uj grf }
procedure UjGraf(var Graf:GrafTip);

{ Ngyzetrcs grf generlsa, kirajzolsa }
procedure RacsGen(var Graf:GrafTip);


implementation

procedure UjGraf(var Graf:GrafTip);
var
  s :GrafNevTip;
  Van, Jo :Boolean;
  i :Byte;
begin
  MentesEll(Graf);
  s := '';
  repeat
    GrafNevBe('Uj grf:', s, Van);
    if Van then begin
      Jo := Graf.Nev <> s;
      if not Jo then GrTovabbS('Az aktulis grfnak is ez a neve !');
    end;
  until not Van or Jo;
  if Jo then begin
    GrafInic(Graf);
    Graf.Nev := s;
    GrafRajz(Graf);
  end;
end;

{ Egy pont kzppontjnak bekrse billentyzetrl vagy egrrel }
procedure PontHelyBe(const Graf:GrafTip; var x,y:Koord; var Van:Boolean);
{ A Van input paramter is. Ha True, akkor x,y-t ajnljuk ki mdostsra }
var
  Jo, JottKoord :Boolean;
  i :PontDbTip;
  s :String;
  cc :Szin;
  t :TLap;
  l :Longint;
begin
  JottKoord := Van;
  with Graf, Pontok do begin
    Jo := False;
    repeat
      if Kezel = Gr then begin
        { csak akkora terleten, hogy a pontot ki tudjuk rajzolni }
        with KeretAdat.Osztas.MunkaT, RR do begin
          t.s1 := s1 + PontSugar[PontMeret];
          t.o1 := o1 + PontSugar[PontMeret];
          t.s2 := s2 - PontSugar[PontMeret];
          t.o2 := o2 - PontSugar[PontMeret];
        end;
        with RR, RT do begin
          Van := Kurzor(t, 'Kzppont:', cx, cy, cc);
          if Van then
            KeprolPont(cx - MinX , cy - MinY, x, y);
        end;
      end else begin
        { Az aktulis kptl fggetlenl brhol lehet }
        { kiajnljuk amit kaptunk }
        EgerKi;
        if JottKoord then Str(x, s) else s := '';
        GrUzen('');
        GrEgSzamBe('Kzppont X:', s, 0, 0, MinKoord, MaxKoord, Van, l);
        if Van then begin
          x := l;
          if JottKoord then Str(y, s) else s := '';
          GrUzen('');
          GrEgSzamBe('Kzppont Y:', s, 0, 0, MinKoord, MaxKoord, Van, l);
          if Van then y := l;
        end;
        EgerBe;
      end;
      if Van then begin
        { Csak ne tegyk r egy msik pontra! }
        Jo := True;
        for i := 1 to PontDb do
          if (x = Pontok[i].X) and
             (y = Pontok[i].Y) then Jo := False;
        if not Jo then
          GrTovabbS('Nem tehetjk r egy msik pontra !');
      end;
    until not Van or Jo;
  end;
end;

{ Pontvlaszts azonost alapjn vagy egrrel }
function PontValaszt(const Graf:GrafTip; Szoveg:String;
                     var PontInd:PontIndTip):Boolean;
var
  cc :Szin;
  s :String;
  AdatVan, Van :Boolean;
begin
  AdatVan := False;
  with Graf, Pontok do
    if PontDb > 0 then begin
      Van := False;
      repeat
        if Kezel = Gr then begin
          with RR, RT do begin
            AdatVan := Kurzor(KeretAdat.Osztas.MunkaT, Szoveg, cx, cy, cc);
            if AdatVan then begin
              LegkozPont(Graf, cx - MinX, cy - MinY, PontInd, Van);
              if not Van then
                GrTovabbS('Nincs a kpen pont !');
            end;
          end;
        end else begin
          s := '';
          EgerKi;
          GrUzen('');
          GrSzovegBe(Szoveg, s, 0, 0, [MinPont..MaxPont],
                     1, 1, [], 0, 0, AdatVan);
          if AdatVan then begin
            PontInd := PontAzonKeres(Graf, s[1], Van);
            if not Van then
              GrTovabb('Nincs ilyen pont !');
          end;
          EgerBe;
        end;
      until not AdatVan or Van;
    end else GrTovabbS('Nincs felvve pont !');
  PontValaszt := AdatVan;
end;

procedure PontInf(const Graf:GrafTip);
var
  p :PontIndTip;
  Van :Boolean;
  s, s1 :String;
begin
  with Graf, Pontok do
    if PontDb = 0 then GrTovabbS('Nincs felvve pont !')
    else
      repeat
        Van := PontValaszt(Graf, 'A kvnt pont:', p);
        if Van then begin
          { pont kiemelse, pontadatok kirsa }
          PontRajz(Pontok[p], True);
          with Pontok[p] do begin
            s := 'Azonost:' + Azon + '  ';
            Str(Tip, s1);
            s := s + 'Tpus:' + s1 + '  ';
            Str(X, s1);
            s := s + 'X:' + s1 + '  ';
            str(Y, s1);
            s := s + 'Y:' + s1 + '  ';
          end;
          GrTovabbS(s);
          { kiemels eltntetse }
          PontRajz(Pontok[p], False);
        end;
      until not Van;
end;

procedure PontFelvitel(var Graf:GrafTip);
var
  Pont :PontRekTip;
  i :PontDbTip;
  Betuk :Jelek;
  c :Char;
  s, s1, st :String;
  Van, Jo :Boolean;
  l :Longint;
  cx, cy :KoordInt;
  x1, y1 :Koord;
begin
  with Graf, Pontok do
    if PontDb = MaxPontDb then GrTovabbS('Nem vehet fel tbb pont !')
    else begin
      Van := False;
      PontHelyBe(Graf, x1, y1, Van);
      if Van then begin
        KeprePont(x1, y1, cx, cy);
        MarkerS(cx, cy);
        { szabad betk kigyjtse }
        Betuk := [MinPont..MaxPont];
        for i := 1 to PontDb do
          Betuk := Betuk - [Pontok[i].Azon];
        { azonost bekrse (a legkisebb szabadot ajnljuk ki) }
        c := MinPont;
        while not (c in Betuk) do Inc(c);
        s := c;
        EgerKi;
        GrUzen('');
        GrSzovegBe('Azonost:', s, 0, 0, Betuk,
                   1, 1, [], 0, 0, Van);
        if Van then begin
          s1 := '1'; { ez legyen az alaprtelmezett ponttpus }
          str(MaxPontTip, st);
          GrUzen('');
          GrEgSzamBe('Tpus (1 - '+st+'):',
                     s1, 0, 0, 1, MaxPontTip, Van, l);
        end;
        EgerBe;
        MarkerS(cx, cy);
        if Van then begin
          with Pont do begin
            Azon := s[1];
            Tip := l;
            x := x1;
            y := y1;
          end;
          PontFelvesz(Graf, Pont);
          VoltMod := True;
          RajzPar(Graf);
          GrafRajz(Graf);
        end;
      end;
    end;
end;

procedure PontTorles(var Graf:GrafTip);
var
  p :PontIndTip;
begin
  with Graf, Pontok do
    if PontDb = 0 then GrTovabbS('Nincs felvve pont !')
    else begin
      if PontValaszt(Graf, 'A trlend pont:', p) then begin
        PontRajz(Pontok[p], True);
        if GrIgenValS('Trljk (az leivel egytt) (I/N)') then begin
          PontTorol(Graf, p);
          VoltMod := True;
          RajzPar(Graf);
          GrafRajz(Graf);
        end else PontRajz(Pontok[p], False);
      end;
    end;
end;

procedure PontMod(var Graf:GrafTip);
var
  p :PontIndTip;
  VanTip, VanKoord, Jo :Boolean;
  x1, y1 :Koord;
  cx, cy :KoordInt;
  s, s1, st :String;
  l :Longint;
begin
  with Graf, Pontok do
    if PontDb = 0 then GrTovabbS('Nincs felvve pont !')
    else begin
      if PontValaszt(Graf, 'A mdostand pont:', p) then begin
        PontRajz(Pontok[p], True);
        if GrIgenValS('Mdostjuk a tpust (I/N)') then begin
          str(Pontok[p].Tip, s);
          str(MaxPontTip, st);
          EgerKi;
          GrUzen('');
          GrEgSzamBe('Tpus (1 - '+st+'):',
                     s, 0, 0, 1, MaxPontTip, VanTip, l);
          EgerBe;
        end else VanTip := False;
        if GrIgenValS('Mdostjuk a koordintit (I/N)') then begin
          Jo := False;
          repeat
            { Nem grafikus koordinta bekrs kiajnlshoz }
            x1 := Pontok[p].x;
            y1 := Pontok[p].y;
            VanKoord := True;
            PontHelyBe(Graf, x1, y1, VanKoord);
            if VanKoord then begin
              s := '';
              Str(x1, s1);
              s := s + 'X:' + s1 + '  ';
              str(y1, s1);
              s := s + 'Y:' + s1 + '  ';
              KeprePont(x1, y1, cx, cy);
              MarkerS(cx, cy);
              Jo := GrIgenValS(s+'Ez legyen az j hely (I/N)');
              MarkerS(cx, cy);
            end;
          until not VanKoord or Jo;
        end else VanKoord := False;
        if VanTip or VanKoord then begin
          with Pontok[p] do begin
            if VanTip then Tip := l;
            if VanKoord then begin
              x := x1;
              y := y1;
            end;
          end;
          VoltMod := True;
          if VanKoord then RajzPar(Graf);
          GrafRajz(Graf);
        end else PontRajz(Pontok[p], False);
      end;
    end;
end;

{ lpontok kivlasztsa, pontok kiemelse, l megkeresse }
procedure ElPontok(const Graf:GrafTip; var k,v:PontIndTip;
                   var AdatVan,ElVan:Boolean);
var
  Poz :ElIndTip;
begin
  AdatVan := False;  ElVan := False;
  with Graf, Pontok do
    if PontValaszt(Graf, 'Kezdpont:', k) then begin
      PontRajz(Pontok[k], True);
      repeat
        AdatVan := PontValaszt(Graf, 'Vgpont:', v);
      until not AdatVan or (k <> v);
      if AdatVan then begin
        PontRajz(Pontok[v], True);
        { van-e ilyen l }
        if Tarol = El then
          with Elek1 do
            Poz := ElKeres(Graf, k, v, ElVan)
        else
          with Elek2 do
            ElVan := Hossz[k,v] > 0;
      end else
        { Ha csak kezdpontot adott meg, szntessk meg annak kiemelst }
        PontRajz(Pontok[k], False);
    end;
end;

{ A k. pontbl a v. pontba men l adatai }
procedure ElAdatok(const Graf:GrafTip; k,v:PontIndTip;
                   var h:ElHossz; var Kat:UtKatTip);
var
  Poz :ElIndTip;
  Van :Boolean;
begin
  with Graf do
    if Tarol = El then
      with Elek1 do begin
        Poz := ElKeres(Graf, k, v, Van);
        with Elek[Poz] do begin
          h := Hossz;
          Kat := UtKat;
        end;
      end
    else
      with Elek2 do begin
        h := Hossz[k,v];
        Kat := UtKat[k,v];
      end;
end;

{ A k. pontbl a v. pontba men l kiemelse, adatainak kirsa }
procedure ElKiir(const Graf:GrafTip; k,v:PontIndTip);
var
  h :ElHossz;
  Kat :UtKatTip;
  s, s1 :String;
  Van :Boolean;
  Poz :ElIndTip;
begin
  with Graf, Pontok do begin
    { pontok kiemelse }
    PontRajz(Pontok[k], True);
    PontRajz(Pontok[v], True);
    { l kiemelse, ladatok kirsa }
    ElAdatok(Graf, k, v, h, Kat);
    ElRajz(Pontok[k], Pontok[v], h, Kat, True);
    s := 'Kp:' + Pontok[k].Azon + '  Vp:' + Pontok[v].Azon + '  ';
    Str(h, s1);
    s := s + 'Hossz:' + s1 + '  ';
    str(Kat, s1);
    s := s + 'Kategria:' + s1 + '  ';
    GrTovabbS(s);
    { kiemels eltntetse }
    ElRajz(Pontok[k], Pontok[v], h, Kat, False);
    PontRajz(Pontok[k], False);
    PontRajz(Pontok[v], False);
  end;
end;

procedure ElInf(const Graf:GrafTip);
var
  ElVan, AdatVan :Boolean;
  k, v :PontIndTip;
  Poz :ElIndTip;
  Db :ElDbTip;
  cc :Szin;
begin
  with Graf, Pontok do begin
    if Tarol = El then Db := Elek1.ElDb
    else Db := ElSzamol(Elek2.Hossz, PontDb);
    if Db > 0 then
      repeat
        ELVan := False;
        if Kezel = Gr then begin
          { a legkzelebbi lt/leket }
          with RR, RT do begin
            AdatVan := Kurzor(KeretAdat.Osztas.MunkaT,
                              'A kvnt l:', cx, cy, cc);
            if AdatVan then begin
              LegkozEl(Graf, cx - MinX, cy - MinY, k, v, ElVan);
              if ElVan then begin
                ElKiir(Graf, k, v);
                { a fordtott l }
                if Tarol = El then
                  with Elek1 do
                    Poz := ElKeres(Graf, v, k, ElVan)
                else
                  with Elek2 do
                    ElVan := Hossz[v,k] > 0;
                if ElVan then
                  ElKiir(Graf, v, k);
              end else
                GrTovabbS('Nincs a kpen l !');
            end;
          end;
        end else begin
          { lkivlaszts pontazonostkkal }
          ElPontok(Graf, k, v, AdatVan, ElVan);
          if AdatVan then
            { csak a megadott irny lt rjuk ki, ha ltezik }
            if ElVan then ElKiir(Graf, k, v)
            else begin
              GrTovabbS('Itt nincs l !');
              PontRajz(Pontok[k], False);
              PontRajz(Pontok[v], False);
            end;
        end;
      until not AdatVan
    else GrTovabbS('Nincs felvve l !');
  end;
end;

procedure ElFelvitel(var Graf:GrafTip);
var
  ElVan, AdatVan :Boolean;
  k, v :PontIndTip;
  s, st :String;
  h, Kat :Longint;
  UjEl :ElRekTip;
  Db :ElDbTip;
  t :Real;
begin
  with Graf, Pontok do begin
    if Tarol = El then Db := Elek1.ElDb
    else Db := ElSzamol(Elek2.Hossz, PontDb);
    if (PontDb >= 2) and (Db < MaxElDb) then begin
      ElPontok(Graf, k, v, AdatVan, ElVan);
      if AdatVan then begin
        if not ElVan then begin
          { lhossz megadsa (a geometriai tvolsgot ajnljuk ki, }
          { ha az mg belefr az lhossz tpusba (Word)) }
          with Pontok[k] do
            t := Tav(x, y, Pontok[v].x, Pontok[v].y);
          if t > 65535 then t := 65535;
          Str(Round(t), s);
          EgerKi;
          GrUzen('');
          GrEgSzamBe('lhossz (1 - 65535):',
                     s, 0, 0, 1, 65535, AdatVan, h);
          EgerBe;
          if AdatVan then begin
            s := '1'; { ez legyen az alaprtelmezs }
            str(MaxUtKat, st);
            EgerKi;
            GrUzen('');
            GrEgSzamBe('Kategria (1 - '+st+'):',
                       s, 0, 0, 1, MaxUtKat, AdatVan, Kat);
            EgerBe;
            if AdatVan then begin
              if Tarol = El then
                with Elek1 do begin
                  with UjEl do begin
                    VpInd := v;
                    Hossz := h;
                    UtKat := Kat;
                  end;
                  ElFelvesz(Graf, k, UjEl);
              end else
                with Elek2 do begin
                  Hossz[k,v] := h;
                  UtKat[k,v] := Kat;
                end;
              VoltMod := True;
              ElRajz(Pontok[k], Pontok[v], h, Kat, False);
            end;
          end;
        end else GrTovabbS('Itt mr van l !');
        { a pontkiemelsek eltntetse }
        PontRajz(Pontok[k], False);
        PontRajz(Pontok[v], False);
      end;
    end else
      if PontDb < 2 then GrTovabbS('Nincs elg pont felvve !')
      else GrTovabbS('Nem vehet fel tbb l !');
  end;
end;

procedure ElTorles(var Graf:GrafTip);
var
  ElVan, AdatVan :Boolean;
  k,v :PontIndTip;
  Db :ElDbTip;
  h :ElHossz;
  Kat :UtKatTip;
begin
  with Graf, Pontok do begin
    if Tarol = El then Db := Elek1.ElDb
    else Db := ElSzamol(Elek2.Hossz, PontDb);
    if Db > 0 then begin
      ElPontok(Graf, k, v, AdatVan, ElVan);
      if AdatVan then begin
        if ElVan then begin
          { kiemeljk }
          ElAdatok(Graf, k, v, h, Kat);
          ElRajz(Pontok[k], Pontok[v], h, Kat, True);
          if GrIgenValS('Trljk (I/N)') then begin
            if Tarol = El then
              with Elek1 do
                ElTorol(Graf, k, v)
            else
              with Elek2 do
                Hossz[k,v] := 0;
            VoltMod := True;
            GrafRajz(Graf);
          end else
            {az lkiemels eltntetse }
            ElRajz(Pontok[k], Pontok[v], h, Kat, False);
        end else GrTovabbS('Itt nincs l !');
        { a pontkiemelsek eltntetse }
        PontRajz(Pontok[k], False);
        PontRajz(Pontok[v], False);
      end;
    end else GrTovabbS('Nincs felvve l !');
  end;
end;

procedure ElMod(var Graf:GrafTip);
var
  ElVan, AdatVan :Boolean;
  k, v :PontIndTip;
  Poz :ElIndTip;
  Db :ElDbTip;
  h :ElHossz;
  Kat :UtKatTip;
  h1, Kat1 :Longint;
  s, s1, st :String;
begin
  with Graf, Pontok do begin
    if Tarol = El then Db := Elek1.ElDb
    else Db := ElSzamol(Elek2.Hossz, PontDb);
    if Db > 0 then begin
      ElPontok(Graf, k, v, AdatVan, ElVan);
      if AdatVan then begin
        if ElVan then begin
          { kiemeljk }
          ElAdatok(Graf, k, v, h, Kat);
          ElRajz(Pontok[k], Pontok[v], h, Kat, True);
          { adatmdosts a meglv adatok kiajnlsval }
          Str(h, s);
          EgerKi;
          GrUzen('');
          GrEgSzamBe('lhossz (1 - 65535):',
                     s, 0, 0, 1, 65535, AdatVan, h1);
          EgerBe;
          if AdatVan then begin
            str(Kat, s);
            str(MaxUtKat, st);
            EgerKi;
            GrUzen('');
            GrEgSzamBe('Kategria (1 - '+st+'):',
                       s, 0, 0, 1, MaxUtKat, AdatVan, Kat1);
            EgerBe;
            if AdatVan then begin
              if Tarol = El then begin
                Poz := ElKeres(Graf, k, v, ElVan);
                with Elek1 do
                  with Elek[Poz] do begin
                    Hossz := h1;
                    UtKat := Kat1;
                  end
              end else
                with Elek2 do begin
                  Hossz[k,v] := h1;
                  UtKat[k,v] := Kat1;
              end;
              VoltMod := True;
              GrafRajz(Graf);           { mert a rgi hosszkirst trljk }
            end;
          end;
          if not AdatVan then
            {az lkiemels eltntetse }
            ElRajz(Pontok[k], Pontok[v], h, Kat, False);
        end else GrTovabbS('Itt nincs l !');
        { a pontkiemelsek eltntetse }
        PontRajz(Pontok[k], False);
        PontRajz(Pontok[v], False);
      end;
    end else GrTovabbS('Nincs felvve l !');
  end;
end;

{ A koordintk a ngyzetrcs miatt szmtandk, a szomszdos pontok }
{ kztti lek, hosszaik s kategrijuk pedig vletlenszeren generlt }
{ A koordintk a vletlenszmok generlsa miatt csak KoordInt tpusak }
procedure NegyzetRacs(var Graf:GrafTip; VPontDb, FPontDb:PontDbTip);
type
  { a rcspontok koordintihoz }
  PozIndTip = 1..MaxPontDb div 2;
  { mivel legalbb kt sora vagy oszlopa lesz a rcsnak }
  PozTip = array[PozIndTip] of KoordInt;

  { Uj pontazonosit generlsa. Egy vletlen, a Betuk-bl hinyz }
  { karaktert generlunk s bvtjk vele a Betuk halmazt.         }
  function UjAzon(var Betuk:Jelek):PontAzonTip;
  var
    c :PontAzonTip;
  begin
    c := Chr(Ord(MinPont) + RandAB(0, MaxPontDb-1));
    while c in Betuk do
      if c = MaxPont then c := MinPont
                     else Inc(c);
    Betuk := Betuk + [c];
    UjAzon := c;
  end;

  { Egy koordintasor helynek vzszintes vagy fggleges kiosztsa }
  procedure Kiosztas(Tol,Ig:KoordInt; Db:PontDbTip; var Poz:PozTip);
  var
    i :PontIndTip;
    Maradek, MinTav, m :KoordInt;
  begin
    { Kt pont kztti minimlis tvolsg }
    MinTav := (Ig - Tol) div Db;
    { A min. ponttvolsg kiosztsnl keletkez helymaradk.  }
    { Ennyi helyet lehet a pontok kztti helyekre sztosztani }
    Maradek := Ig - Tol - MinTav*(Db-1);
    { Elszr eltolsi tvolsgokat generlunk }
    Poz[1] := 0; { az els pontot nem toljuk el }
    for i := 2 to Db do begin
      { minden pont az elztl legalbb MinTav }
      { s legfeljebb 3*Mintav tvolsgra kerl }
      m := RandAB(0, MiniMal(Maradek, 2*MinTav));
      Poz[i] := Poz[i-1] + MinTav + m;
      Dec(Maradek, m);
    end;
    { Az eltolsi tvolsgok talaktsa koordintkk. }
    Inc(Tol, RandAB(0, Maradek));
    for i := 1 to Db do Inc(Poz[i], Tol);
  end;

  { l generlsa (a grf pontjai mr generlva vannak) }
  procedure ElGen(Bol,Ba:PontAzonTip);
  var
    UjEl :ElRekTip;
    KpInd, VpInd :PontIndTip;
    Van :Boolean;
  begin
    with Graf, Pontok do begin
      { pontkeress }
      KpInd := PontAzonKeres(Graf, Bol, Van);
      VpInd := PontAzonKeres(Graf, Ba, Van);
      { lgenerls }
      if Random(2) = 1 then begin { 1/2 valsznsggel vesznk fel ide lt }
        if Tarol = El then
          with Elek1 do begin
            UjEl.VpInd := VpInd;
            with UjEl do begin
              Hossz := RandAB(1, 999);
              UtKat := RandAB(1, MaxUtKat);
            end;
            ElFelvesz(Graf, KpInd, UjEl);
          end
        else
          with Elek2 do begin
            Hossz[KpInd, VpInd] := RandAB(1, 999);
            UtKat[KpInd, VpInd] := RandAB(1, MaxUtKat);
          end;
      end;
    end;
  end;
var
  Pont :PontRekTip;
  i,j :PontIndTip;
  XPoz, YPoz :PozTip;
  Tabla :array[PozIndTip, PozIndTip] of PontAzonTip;
  Betuk :Jelek;
begin
  Betuk := [];
  { koordinta generls }
  Kiosztas(-10000, 10000, FPontDb, YPoz);
  Kiosztas(-10000, 10000, VPontDb, XPoz);
  { pontgenerls }
  for i := 1 to FpontDb do begin
    Pont.y := YPoz[i];
    for j := 1 to VpontDb do begin
      Pont.x := XPoz[j];
      Pont.Azon := UjAzon(Betuk);
      Pont.Tip := RandAB(1, MaxPontTip);
      Tabla[i,j] := Pont.Azon;
      { trols }
      with Graf.Pontok do
        PontFelvesz(Graf, Pont);
    end;
  end;

  { lgenerls a Tabla alapjn (a szlekrl csak "befel" mehet l) }
  with Graf.Pontok do
    for i := 1 to FPontDb do
      for j := 1 to VpontDb do begin
        if i > 1 then ElGen(Tabla[i,j], Tabla[i-1,j]);          { fel }
        if i < FPontDb then ElGen(Tabla[i,j], Tabla[i+1,j]);    { le }
        if j > 1 then ElGen(Tabla[i,j], Tabla[i,j-1]);          { balra }
        if j < VPontDb then ElGen(Tabla[i,j], Tabla[i,j+1]);    { jobbra }
      end;
end;

{ Ngyzetrcs grf generlsa, kirajzolsa }
procedure RacsGen(var Graf:GrafTip);
var
  Nev :GrafNevTip;
  VDb, FDb :PontIndTip;
begin
  if MaxPontDb >= 4 then begin  { mivel a rcs legalbb 2x2-es lesz }
    MentesEll(Graf);
    GrafInic(Graf);
    VDb := RandAB(2, MaxPontDb div 2);       { vzszintes rcspontok szma }
    { VDb*FDb nem lehet MaxPontDb-nl nagyobb, hogy legyen elg azonost  }
    FDb := RandAB(2, MaxPontDb div VDb);     { fggleges rcspontok szma }
    { a hasznlt rajzterleten a max. pontmrettel   }
    { max. 6 sor ill. 7 oszlop fr el szp kllemben }
    Negyzetracs(Graf, MiniMal(VDb, 7), MiniMal(FDb, 6));
    { nvknt egy vletlen nagybett generlunk }
    Graf.Nev := Chr(RandAB(65,90));
    RajzPar(Graf);
    GrafRajz(Graf);
  end else
    GrTovabbS('Ennyi pontbl nem generlhat ngyzetes grf!');
    { ez csak akkor lehet, ha a MaxPont, MinPont konstansokat gy  }
    { mdostjuk, hogy az intervallumukba nem esik legalbb 4 elem }
  end;

end.
