unit GrafMUt;      { Grf minimlis t algoritmusok }

interface

uses GrafDekl, GrafKez, GrafGraf, GrafMod;

const
  MaxTav = MaxLongInt;

type
  Tav = 0..MaxTav;
  TavMatrix = array[PontIndTip,PontIndTip] of Tav;
  TavTomb = array[PontIndTip] of Tav;

  Cimke = PontIndTip;
  CimkeMatrix = array[PontIndTip,PontIndTip] of Cimke;
  CimkeTomb = array[PontIndTip] of Cimke;


{ Minimlis t keresse s kirajzolsa }
procedure MinUt(const Graf:GrafTip);


implementation


procedure Warshall(const Graf:GrafTip; var T:TavMatrix; var C:CimkeMatrix);
var
  x,y,w :PontIndTip;
begin
  with Graf, Pontok, Elek2 do begin
    { Kezdllapot }
    for x := 1 to PontDb do
      for y := 1 to PontDb do begin
        if Hossz[x,y] > 0 then T[x,y] := Hossz[x,y] else T[x,y] := MaxTav;
        C[x,y] := y;
      end;
    { Javt lpsek }
    for w := 1 to PontDb do
      for x := 1 to PontDb do
        for y := 1 to PontDb do
          if (T[x,w] < MaxTav) and (T[w,y] < MaxTav) then
          { Hogy ne legyen aritmetikai tlcsorduls }
            if T[x,w] + T[w,y] < T[x,y] then begin
              T[x,y] := T[x,w] + T[w,y];
              C[x,y] := C[x,w];
            end;
  end;
end;

procedure Dijkstra1(const Graf:GrafTip; var T:TavTomb;
                    var C:CimkeTomb; KezdoPont:PontIndTip);
{ Az aktv pontok indexeit tmbben troljuk (rendezetlenl) }
var
  A :array[PontIndTip] of PontIndTip;
  Aktiv :array[PontIndTip] of Boolean;
  ADb :PontDbTip;
  x, y, i, MinInd :PontIndTip;
  l :ElDbTip;
begin
  with Graf, Pontok, Elek1 do begin
    { Kezdllapot }
    for i := 1 to PontDb do begin
      T[i] := MaxTav;
      Aktiv[i] := False;
    end;
    T[KezdoPont] := 0;
    C[KezdoPont] := KezdoPont;
    ADb := 1;
    A[ADb] := KezdoPont;
    Aktiv[KezdoPont] := True;

    { Javt lpsek }
    while ADb > 0 do begin
      MinInd := 1;
      for i := 2 to ADb do
        if T[A[i]] < T[A[MinInd]] then MinInd := i;
      x := A[MinInd];
      { x trlse az aktv pontok kzl az utols rmsolsval }
      A[MinInd] := A[ADb];
      Dec(ADb);
      Aktiv[x] := False;
      { 'Rvidts' x-en keresztl }
      for l := ElMut[x] to ElMut[x+1]-1 do with Elek[l] do begin
        y := VpInd;
        if (T[x] < MaxTav) and (Hossz < MaxTav) then
          { Hogy ne legyen aritmetikai tlcsorduls }
          if T[x] + Hossz < T[y] then begin
            T[y] := T[x] + Hossz;
            C[y] := x;
            if not Aktiv[y] then begin
              { bvtjk az aktv pontokat y-al }
              Inc(ADb);
              A[ADb] := y;
              Aktiv[y] := True;
            end;
          end;
      end;
    end;
  end;
end;

procedure Dijkstra2(const Graf:GrafTip; var T:TavTomb;
                    var C:CimkeTomb; KezdoPont:PontIndTip);
{ Az aktv pontok indexeit tmbben troljuk tvolsg szerint rendezetten }
var
  A :array[PontIndTip] of PontIndTip;
  Aktiv :array[PontIndTip] of Boolean;
  ADb, j :PontDbTip;
  x, y, i :PontIndTip;
  l :ElDbTip;
begin
  with Graf, Pontok, Elek1 do begin
    { Kezdllapot }
    for i := 1 to PontDb do begin
      T[i] := MaxTav;
      Aktiv[i] := False;
    end;
    T[KezdoPont] := 0;
    C[KezdoPont] := KezdoPont;
    ADb := 1;
    A[ADb] := KezdoPont;
    Aktiv[KezdoPont] := True;

    { Javt lpsek }
    while ADb > 0 do begin
      x := A[1];    { az els pont a minimlis tvolsg }
      { x trlse az aktv pontok kzl elrelptetssel }
      for i := 2 to ADb do A[i-1] := A[i];
      Dec(ADb);
      Aktiv[x] := False;
      { 'Rvidts' x-en keresztl }
      for l := ElMut[x] to ElMut[x+1]-1 do with Elek[l] do begin
        y := VpInd;
        if (T[x] < MaxTav) and (Hossz < MaxTav) then
          { Hogy ne legyen aritmetikai tlcsorduls }
          if T[x] + Hossz < T[y] then begin
            T[y] := T[x] + Hossz;
            C[y] := x;
            if not Aktiv[y] then begin
              { y besorolsa az aktv pontok kz tvolsg szerint }
              j := ADb;
              while (j >= 1) and (T[y] <= T[A[j]]) do begin { helykszts }
                A[j+1] := A[j];                             { helykeresssel }
                Dec(j);
              end;
              { Megjegyezzk, hogy az azonos elemeket nem kellene 'htrbb' }
              { lptetni (azaz T[y] < T[A[j]] felttellel hatkonyabb a }
              { besorols), de gy sszhangban maradunk a cikk pldjval. }
              { (lsd: 10b.bra j s c pontjait a 4. lpsben) }
              A[j+1] := y;
              Inc(ADb);
              Aktiv[y] := True;
            end else begin
              { Az aktv pontok kztt lv y tvolsga cskkent, ezrt }
              { t helyre kell tennnk a tvolsg szerint rendezett aktv }
              { pontok A tmbjben. Az eltte lv, nla nagyobb tvolsg }
              { pontokat 'htrbb' lptetjk, majd y-t a helyre tesszk }
              j := ADb;
              while (j >= 1) and (A[j] <> y) do Dec(j); { rllunk y-ra }
              if j > 1 then begin
                Dec(j);
                while (j >= 1) and (T[A[j]] > T[y]) do begin { helykszts }
                  A[j+1] := A[j];                             { helykeresssel }
                  Dec(j);
                end;
                A[j+1] := y;
              end;
            end;
          end;
      end;
    end;
  end;
end;

procedure Dijkstra3(const Graf:GrafTip; var T:TavTomb;
                    var C:CimkeTomb; KezdoPont:PontIndTip);
{ Az aktv pontok indexeit tmbben troljuk }
{ tvolsg szerint halmot/binris ft ptve bellk }
var
  A :array[PontIndTip] of PontIndTip;
  Aktiv :array[PontIndTip] of Boolean;
  ADb, j :PontDbTip;
  x, y, i :PontIndTip;
  l :ElDbTip;

  procedure Sullyeszt(n :PontIndTip);         { Besllyeszti az A[1] elemet }
  var                                         { az A[2],...,A[n] halomba }
    i, x :PontIndTip;
    j :Integer;
    Vege :Boolean;
  begin
    x := A[1];                                 { az A[1] megjegyzse }
    i := 1; j := 2*i; Vege := False;
    while (j <= n) and not Vege do begin       { helykszts pakolssal }
      if (j < n) and
         (T[A[j+1]] < T[A[j]]) then Inc(j);    { a kisebb elem gn sllyed }
      if T[x] > T[A[j]] then begin
        A[i] := A[j]; i := j; j := 2*i;
      end else Vege := True;
    end;
    A[i] := x;                                 { A[1]-t a helyre }
  end;

  procedure Bovit(n :PontIndTip);               { Bvti az A[n] elemmel }
  var                                           { az A[1],...,A[n-1] halmot }
    i, x :PontIndTip;
    j :Integer;
    Vege :Boolean;
  begin
    x := A[n];                                 { az A[n] megjegyzse }
    i := n; j := i div 2; Vege := False;
    while (j >=1) and not Vege do begin        { helykszts pakolssal }
      if T[x] < T[A[j]] then begin
        A[i] := A[j]; i := j; j := i div 2;
      end else Vege := True;
    end;
    A[i] := x;                                 { A[n]-t a helyre }
  end;

  procedure Helyere(y :PontIndTip);       { Helyre viszi az y pontot }
  var                                     { (aminek kisebb lett a tvja) }
    i, x :PontIndTip;                     { a halomban }
    j :Integer;
    Vege :Boolean;
  begin
    i := 1;
    while A[i] <> y do Inc(i);                 { rllunk y-ra }

    x := A[i];                                 { az A[i] (=y) megjegyzse }
    j := i div 2; Vege := False;
    while (j >=1) and not Vege do begin        { helykszts pakolssal }
      if T[x] < T[A[j]] then begin
        A[i] := A[j]; i := j; j := i div 2;
      end else Vege := True;
    end;
    A[i] := x;                                 { y-t a helyre }
  end;

begin
  with Graf, Pontok, Elek1 do begin
    { Kezdllapot }
    for i := 1 to PontDb do begin
      T[i] := MaxTav;
      Aktiv[i] := False;
    end;
    T[KezdoPont] := 0;
    C[KezdoPont] := KezdoPont;
    ADb := 1;
    A[ADb] := KezdoPont;
    Aktiv[KezdoPont] := True;

    { Javt lpsek }
    while ADb > 0 do begin
      x := A[1];                       { az els pont a minimlis tvolsg }
      A[1] := A[ADb];         { x trlse az aktv pontok kzl gy, hogy a }
      Dec(ADb);               { halom utols elemt besllyesszk az eggyel }
      if ADb >= 2 then        { kevesebb elemet tartalmaz halomba          }
        Sullyeszt(ADb);
      Aktiv[x] := False;
      { 'Rvidts' x-en keresztl }
      for l := ElMut[x] to ElMut[x+1]-1 do with Elek[l] do begin
        y := VpInd;
        if (T[x] < MaxTav) and (Hossz < MaxTav) then
          { Hogy ne legyen aritmetikai tlcsorduls }
          if T[x] + Hossz < T[y] then begin
            T[y] := T[x] + Hossz;
            C[y] := x;
            if not Aktiv[y] then begin
              { bvtjk az aktv pontokat y-al gy, hogy a halom legvgre }
              { tesszk, majd onnan a helyre lptetjk a Bovit eljrssal  }
              Inc(ADb);
              A[ADb] := y;
              Bovit(ADb);
              Aktiv[y] := True;
            end else
              { az aktv pontok kztt lv y tvolsga cskkent, ezrt }
              { t helyre kell tennnk a tvolsg szerint halmot alkot }
              { aktv pontok A tmbjben }
              Helyere(y);
          end;
      end;
    end;
  end;
end;

{ Minimlis t keresse s kirajzolsa }
procedure MinUt(const Graf:GrafTip);
const
  Modszer = 3; { ltrols esetn a leggyorsabb mdszerrel szmoljunk }
var
  Kp, Vp, p, i :PontIndTip;
  EKp :PontDbTip;
  TM :TavMatrix;
  CM :CimkeMatrix;
  TT :TavTomb;
  CT :CimkeTomb;
  UtPontok :CimkeTomb;
  UtPontDb :PontDbTip;
  UtHossz :Tav;
  Hossz :ElHossz;
  Kat :UtKatTip;
  Van :Boolean;
  s, st :String;
begin
  with Graf, Pontok do
    if PontDb <= 1 then GrTovabbS('Nincs elg pont felvve !')
    else begin
      EKp := 0;                                   { Az elz t kezdpontja }
      repeat
        Van := PontValaszt(Graf, 'Kezdpont:', Kp);
        if Van then begin
          PontRajz(Pontok[Kp], True);
          repeat
            Van := PontValaszt(Graf, 'Vgpont:', Vp);
          until Van and (Kp <> Vp) or not Van;
          if Van then begin
            PontRajz(Pontok[Vp], True);
            { A minimlis t megkeresse s 'sszeraksa' az UtPontok tmbbe }
            if Tarol = El then begin
              { Csak ms kezdpont esetn 'keresnk' jra }
              if EKp <> Kp then begin
                case Modszer of
                  1:Dijkstra1(Graf, TT, CT, Kp);
                  2:Dijkstra2(Graf, TT, CT, Kp);
                  3:Dijkstra3(Graf, TT, CT, Kp);
                end;
                EKp := Kp;
              end;
              if TT[Vp] = MaxTav then UtPontDb := 0
              else begin
                UtHossz := TT[Vp];
                UtPontDb := 1;
                UtPontok[UtPontDb] := Vp;
                p := Vp;
                repeat
                  { az elz pontot beszrjuk a pontok el }
                  p := CT[p];
                  for i := UtPontDb downto 1 do UtPontok[i+1] := Utpontok[i];
                  UtPontok[1] := p;
                  Inc(UtPontDb);
                until p = Kp;
              end;
            end else begin
              if EKp = 0 then begin          { Elegend egyszer 'keresnnk' }
                Warshall(Graf, TM, CM);
                EKp := Kp;
              end;
              if TM[Kp,Vp] = MaxTav then UtPontDb := 0
              else begin
                UtHossz := TM[Kp,Vp];
                UtPontDb := 1;
                UtPontok[UtPontDb] := Kp;
                p := Kp;
                repeat
                  { a kvetkez pontot a pontok mg }
                  p := CM[p,Vp];
                  Inc(UtPontDb);
                  UtPontok[UtPontDb] := p;
                until p = Vp;
              end;
            end;
            s := 'Kezdpont: ' + Pontok[Kp].Azon + '  ' +
                 'Vgpont: ' + Pontok[Vp].Azon + '  ';
            if UtPontDb = 0 then begin
              GrTovabbS(s + 'Nincs ilyen t ! ');
              PontRajz(Pontok[Kp], False);
              PontRajz(Pontok[Vp], False);
            end else begin
              { A minimlis t kirajzolsa s a hossz kirsa }
              for i := 1 to UtPontDb-1 do begin
                ElAdatok(Graf, UtPontok[i], UtPontok[i+1], Hossz, Kat);
                ElRajz(Pontok[UtPontok[i]], Pontok[UtPontok[i+1]],
                       Hossz, Kat, True);
                { a kezd s vgpont mr ki volt emelve }
                if UtPontok[i+1] <> Vp then
                  PontRajz(Pontok[UtPontok[i+1]], True);
              end;
              Str(UtHossz, st);
              GrTovabbS(s + 'sszhossz: ' + st + ' ');
              { A kiemelsek megszntetse }
              PontRajz(Pontok[UtPontok[1]], False);
              for i := 1 to UtPontDb-1 do begin
                ElAdatok(Graf, UtPontok[i], UtPontok[i+1], Hossz, Kat);
                ElRajz(Pontok[UtPontok[i]], Pontok[UtPontok[i+1]],
                       Hossz, Kat, False);
                PontRajz(Pontok[UtPontok[i+1]], False);
              end;
            end;
          end else PontRajz(Pontok[Kp], False);
        end;
      until not Van;
    end;
end;

end.